;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; In the name of god
;; Rafsanjan Plain Environment (4902)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

extensions
[
  gis
  matrix
  csv
]

breed [Farmers Farmer]
breed [EnvAgencys EnvAgency]

globals

[SA-drawdown SA-market-participant SA-breaches SA-water-permits mean-three-consecutive-years remain-bc
  SA-crop-production
  SA-transacted-price
  SA-transacted-amount
  SA-socres
  total-consumer-surplus
  total-producer-surplus
  max-willingness-to-buy
  min-willingness-to-sell
  Social-Welfare
  residual-supply-of-sellers
  residual-demand-of-buyers
  putative-transacted-volume
  Ky
  Yp
  tick-prime
  fixed-head-inflow-west-below-patches
  fixed-head-inflow-west-above-patches
  fixed-head-inflow-west-middle-patches
  fixed-head-inflow-south-patches
  fixed-head-inflow-east-above-patches
  fixed-head-inflow-east-below-patches
  fixed-head-inflow-east-middle-patches
  fixed-head-outflow-east-right-above-patches
  fixed-head-outflow-east-right-below-patches
  fixed-head-outflow-west-right-above-patches
  fixed-head-outflow-west-right-below-patches
  fixed-head-outflow-west-right-middle-patches
  fixed-head-outflow-east-left-above-patches
  fixed-head-outflow-east-left-below-patches
  fixed-head-outflow-east-left-middle-patches
  fixed-head-outflow-west-left-above-right-patches
  fixed-head-outflow-west-left-above-left-patches
  fixed-head-outflow-west-left-below-patches
  fixed-head-outflow-west-left-middle-patches

  stall
  list-all-year-precipitation
  num-transaction
  Market-was-running?
  model-ready?
  ;;;;;;groundwater model formulation;;;;;;

  active-cells-remap
  number-of-unknowns
  A
  C
  inverse-A
  solution-vector
  max-head
  min-head
  min-K
  max-K
  H-unit-hydrograph

  ;;;;;;Social mode;;;;;;

  year
  month
 total-demand
  total-supply



  ;;;;;;Efficiency;;;;;
  list-of-interior-patches-with-well
  interior-patches
  my-ATimesH
  Total-ATimesH

fine-magnitude-intensified

  KermanPCP-patches
  AnarPCP-patches
  global-list-buyers-this-year
  global-list-buyers-all-time
  global-list-sellers-this-year
  global-list-sellers-all-time
  global-mean-target-price
  global-list-transaction-prices-this-year

  expected-value-equilibrium-price


  global-list-bid-price
  global-list-bought-amountprice-all-time
  global-list-sold-amountprice-all-time
  global-list-bought-amountprice-this-year
  global-list-sold-amountprice-this-year
  global-supply-price-points-all-time
  global-demand-price-points-all-time
  global-supply-price-points-this-year
  global-demand-price-points-this-year


  global-sellers-list-min-to-max
  global-buyers-list-max-to-min
  Excess-Demand
  Excess-Supply




    compliance-level                             ;; the compliance % = #cooperators / (#cooperators+#defectors)


  ;;;;;lorenz and gini;;;;;

  gini-index-reserve
  lorenz-points
  sorted-wealths

      ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;;;;;;;;;;;;; EXPERIMENTS TIMESERIES ;;;;;;;;;;;;;;;
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  TS-norm-strength
  TS-compliance
  TS-gini-wealth
  TS-watertable-mean
  TS-watertable-std
  TS-decision-representative-farmer
  TS-drawdowns-mean
  TS-drawdowns-std
  TS-profits-mean
  TS-cummulative-wealth-median
  TS-total-breaches
  TS-boldness
  TS-vengefulness


    defectors                                    ;; the agentset of defecting farmers
  cooperators                                  ;; the agentset of cooperating farmers



]

EnvAgencys-own
[EnvAgency-RentSeeking EnvAgency-LearningRate EnvAgency-Reservation-Price Turtle-Demnad-test
  BC
  Alpha
  Turtle-willingness-to-buy
  list-prices
  Turtle-Demand?
  Turtle-Demand
  Turtle-Supply
  Turtle-Supply?
  Turtle-Transaction?
  Turtle-list-bought-amountprice-this-year
  Turtle-list-bought-amountprice-all-time
  Turtle-target-price
  Turtle-bought-water
]
Farmers-own
[
  Consumer-Surplus
  Producer-Surplus

  Turtle-Demand?
  Turtle-Supply?
  Turtle-Demand
  Farmer-Supply
  Turtle-Transaction?
  Farmer-WP0
  Farmer-WP
  Farmer-ID
  Farmer-I
  strategy
  residual-deficit-supply
  list-of-strategy-score
  list-of-scores
  list-of-strategies
  mean-deficit-irrigation


  Farmer-MB
  Farmer-reservation-price
  Turtle-willingness-to-buy
  Farmer-willingness-to-sell
  Turtle-target-price
  Turtle-list-bought-amountprice-this-year
  Farmer-list-sold-amountprice-this-year
  Turtle-bought-water
  Farmer-sold-water
  Farmer-LearningRate
  Farmer-RentSeeking
  Farmer-this-year-pumping-costph
  Farmer-this-year-TOutput-tonph


  Farmer-WaterUsage   ;;mm per m2 per year
  Farmer-IDmm
  E-score
  score
  I-score
  score-accumulated
  score-history-list
  this-year-vengefulness-toward-neighbors
  boldness          ;;the farmer's boldness [0,1]
                    ;;the farmer's vengefulness [0,1]
  V1
  ave-vengefulness
  decision

  Farmer-Breach
  breach-severity
  times-caught-defecting
  times-reported
  times-punished-others


  Turtle-list-bought-amountprice-all-time
  Farmer-list-sold-amountprice-all-time
  Farmer-TProfit2
  Farmer-TProfit1
  Farmer-pumping-cost2ph
  Farmer-pumping-cost1ph
  Farmer-O2ph
  Farmer-O1ph
  Farmer-R2ph
  Farmer-R1ph
  Farmer-patches
  Farmer-count-patches
  Farmer-num-wells
  Farmer-this-year-Rph
  Farmer-this-year-TProfit
  Farmer-this-year-TProfitph
  Farmer-this-year-outputph
  Farmer-this-year-transaction-cost


 MFarmer-this-year-TOutput-tonphNeighbors
            ;;the farmer's decision ["cooperate","defect"]
  cummulative-wealth

  long-neighbors-list
  neighbors-list

 Farmer-farm-water-table
  farm-area-total




]

patches-own
[
  ;; of paramount importance features


  elevation
  H
  real-H
  water-table
  real-water-table
  Qwell
  area-under-production
  number-of-wells-here
  number-of-Farmer-wells-here
  number-of-Industry-wells-here
  number-of-Domestic-wells-here
  Drawdown-from-Mehr
  Qwell-Farmer
  Qwell-Industry
  Qwell-Domestic

  WP                                  ;; Ml/year
  WP0
  ID                                  ;; million liter per month
  IDm
  Supply?
  Demand?
  Supplym
  Demandm
  Supply
  Demand
  Precipitation                       ;; mm / (m2 * year)
  this-year-precipitation
  Qt                                  ;; mm / (m2 * year)
  Ut



  district


  owner
  my-neighbors








 ;;;;;;;head values;;;;;;

                                    ;; heads at the new timestep
  Hinew                               ;; a reference to measure drawdowns from now
  Hinitial                            ;; a reference H to calculate drawdowns
  patch-number-tag





  ;;;;;;;booleans;;;;;;

  well?
  recharge?
  Pizo?
  interior-node?
  fixed-head?
  no-flow?
  adjacent-to-boundary?
  inactive-patch?                          ;; inactive (ghost) cells which are outside the problem domain (T = 0 no-flow)
  top-right-corner?
  top-left-corner?
  bottom-right-corner?
  bottom-left-corner?
  top-row?
  bottom-row?
  right-column?
  left-column?
  N-peninsula?
  S-peninsula?
  E-peninsula?
  W-peninsula?
  ;;;;;;;;source and sink terms;;;;;;;

                               ;; well pumping rate                                        [L3/T]
  Qwell-temp                          ;; temporary dummy variable to initialize heads
                              ;; recharge                                                 [L3/L2*T] ~ [L/T]
  Recharge-temp                       ;; temporary dummy variable to initialize heads

  ;;;;;;patch hydraulic parameters;;;;;;;

  S-patch                                  ;; storativity of each patch
  S-patch-temp                             ;; temporary dummy variable to solve for steady state
  K-patch                                  ;; conductivity of each patch
  T-patch                                  ;; transmissivity of each patch
  sourceterm
  TN
  TS
  TE
  TW
  TC
  Ncof
  Scof
  Ecof
  Wcof
  Ccof
  RHS
  N-neighbour
  S-neighbour
  E-neighbour
  W-neighbour
  corresponding-pizo
  list-of-wells-here
  area-monitored-patches-by-this-Pizo
  Recharge
  PCP-coefficient
  potential-ET



]

__includes [
  "WaterFarmerMarket.nls"
  "calibration.nls"
]

to setup-GroundWater
  clear-all
  reset-ticks
  set year 2002                                                          ;; time starts from Mehr 1382
  setup-world
  setup-gis
  initial-water-table
  setup-hydrolic-parameters
  setup-sources
  setup-maxmin-heads
  setup-neighbours
  setup-patch-numbering
  setup-patches-adjacent-to-boundary


end

to setup-world

  set ok-Pizos-Num
  [
    3 4 7 8 9 10 11 13
    14 15 19 20 24 26 31 33
    34 38 39 43 44 49 50 51
    53 56 58 59 60 63 65 66 69 70 72 74 76 77 79 80 81 82
  ]
  read-in-data

    ;; initialize patches vatriables:

  ask patches [set pcolor white set interior-node? false set inactive-patch? true set adjacent-to-boundary? false set fixed-head? false set no-flow? false set well? false set recharge? false
  set Pizo? false  set Qwell 0 set Recharge 0 set K-patch 0]
  set-patch-size 12

end

to setup-gis

  ;; load gis data:

  gis:load-coordinate-system "Projection.prj"
  let thiessen-dataset gis:load-dataset "thiessenPolygon.shp"
  let aquifer-polygon-dataset gis:load-dataset "AquiferPolygon.shp"

  let fixed-head-inflow-west-above-dataset gis:load-dataset "fixed-head-inflow-west-above.shp"
  let fixed-head-inflow-west-below-dataset gis:load-dataset "fixed-head-inflow-west-below.shp"
  let fixed-head-inflow-west-middle-dataset gis:load-dataset "fixed-head-inflow-west-middle.shp"

  let fixed-head-inflow-south-dataset gis:load-dataset "fixed-head-inflow-south.shp"

  let fixed-head-inflow-east-above-dataset gis:load-dataset "fixed-head-inflow-east-above.shp"
  let fixed-head-inflow-east-below-dataset gis:load-dataset "fixed-head-inflow-east-below.shp"
  let fixed-head-inflow-east-middle-dataset gis:load-dataset "fixed-head-inflow-east-middle.shp"

  let center-fixed-head-inflow-dataset gis:load-dataset "centerOfFiexedHeadInflow.shp"

  let fixed-head-outflow-west-left-above-right-dataset gis:load-dataset "fixed-head-outflow-west-left-above-right.shp"
  let fixed-head-outflow-west-left-above-left-dataset gis:load-dataset "fixed-head-outflow-west-left-above-left.shp"
  let fixed-head-outflow-west-left-below-dataset gis:load-dataset "fixed-head-outflow-west-left-below.shp"
  let fixed-head-outflow-west-left-middle-dataset gis:load-dataset "fixed-head-outflow-west-left-middle.shp"

  let fixed-head-outflow-east-left-above-dataset gis:load-dataset "fixed-head-outflow-east-left-above.shp"
  let fixed-head-outflow-east-left-below-dataset gis:load-dataset "fixed-head-outflow-east-left-below.shp"
  let fixed-head-outflow-east-left-middle-dataset gis:load-dataset "fixed-head-outflow-east-left-middle.shp"

  let fixed-head-outflow-west-right-above-dataset gis:load-dataset "fixed-head-outflow-west-right-above.shp"
  let fixed-head-outflow-west-right-below-dataset gis:load-dataset "fixed-head-outflow-west-right-below.shp"
  let fixed-head-outflow-west-right-middle-dataset gis:load-dataset "fixed-head-outflow-west-right-middle.shp"


  let fixed-head-outflow-east-right-above-dataset gis:load-dataset "fixed-head-outflow-east-right-above.shp"
  let fixed-head-outflow-east-right-below-dataset gis:load-dataset "fixed-head-outflow-east-right-below.shp"

  let no-flow-bc-dataset gis:load-dataset "no-flow.shp"
  let Pizo-dataset gis:load-dataset "SelectedPizos.shp"
  let DEM-dataset gis:load-dataset  "extent.asc"
  let all-wells-dataset gis:load-dataset "ModifiedAquiferWells.shp"
  gis:set-world-envelope (gis:envelope-union-of (gis:envelope-of DEM-dataset))


    ;; set intersecting values:

    ;; DEM:
  resize-world 0 gis:width-of DEM-dataset  0 gis:height-of DEM-dataset
  gis:apply-raster DEM-dataset elevation
  scale-color-elevation

    ;; aquifer data:

  ask patches gis:intersecting aquifer-polygon-dataset [set interior-node? true set fixed-head? false set no-flow? false set inactive-patch? false]

  set fixed-head-inflow-west-above-patches patches gis:intersecting fixed-head-inflow-west-above-dataset
  set fixed-head-inflow-west-below-patches patches gis:intersecting fixed-head-inflow-west-below-dataset
  set fixed-head-inflow-west-middle-patches patches gis:intersecting fixed-head-inflow-west-middle-dataset

  set fixed-head-inflow-south-patches patches gis:intersecting fixed-head-inflow-south-dataset

  set fixed-head-inflow-east-above-patches patches gis:intersecting fixed-head-inflow-east-above-dataset
  set fixed-head-inflow-east-below-patches patches gis:intersecting fixed-head-inflow-east-below-dataset
  set fixed-head-inflow-east-middle-patches patches gis:intersecting fixed-head-inflow-east-middle-dataset

  set fixed-head-outflow-east-right-above-patches patches gis:intersecting fixed-head-outflow-east-right-above-dataset
  set fixed-head-outflow-east-right-below-patches patches gis:intersecting fixed-head-outflow-east-right-below-dataset

  set fixed-head-outflow-west-right-above-patches patches gis:intersecting fixed-head-outflow-west-right-above-dataset
  set fixed-head-outflow-west-right-below-patches patches gis:intersecting fixed-head-outflow-west-right-below-dataset
  set fixed-head-outflow-west-right-middle-patches patches gis:intersecting fixed-head-outflow-west-right-middle-dataset

  set fixed-head-outflow-east-left-above-patches patches gis:intersecting fixed-head-outflow-east-left-above-dataset
  set fixed-head-outflow-east-left-below-patches patches gis:intersecting fixed-head-outflow-east-left-below-dataset
  set fixed-head-outflow-east-left-middle-patches patches gis:intersecting fixed-head-outflow-east-left-middle-dataset

  set fixed-head-outflow-west-left-above-right-patches patches gis:intersecting fixed-head-outflow-west-left-above-right-dataset
  set fixed-head-outflow-west-left-above-left-patches patches gis:intersecting fixed-head-outflow-west-left-above-left-dataset
  set fixed-head-outflow-west-left-below-patches patches gis:intersecting fixed-head-outflow-west-left-below-dataset
  set fixed-head-outflow-west-left-middle-patches patches gis:intersecting fixed-head-outflow-west-left-middle-dataset



    ;; inflow in the water balance duration (1385-86 or 2006-07) is 76.211 MCM/year, however it is set 97.211 MCM per year because the perimitor of out fixed head cells are lower than reality.
    ;;Real length of inflow boundaries is 188 km. Assume that aquifer is located 800 meters bellow the surface topology
    ;;so the aquifer bottom's elevation from the sea level would be: elevation - 800

  ;let inflow-H ((yearly-inflow * 10 ^ 6 * 365) / ( delta ) / (count fixed-head-inflow-patches * delta))
  ask fixed-head-inflow-west-above-patches
  [
    set pcolor blue set interior-node? false set fixed-head? true set no-flow? false
    set inactive-patch? false set well? false ;set H precision  (elevation - bottom-of-aquifer + inflow-H) 0
  ]
    ask fixed-head-inflow-west-below-patches
  [
    set pcolor blue set interior-node? false set fixed-head? true set no-flow? false
    set inactive-patch? false set well? false ;set H precision  (elevation - bottom-of-aquifer + inflow-H) 0
  ]

    ask fixed-head-inflow-west-middle-patches
  [
    set pcolor blue set interior-node? false set fixed-head? true set no-flow? false
    set inactive-patch? false set well? false ;set H precision  (elevation - bottom-of-aquifer + inflow-H) 0
  ]

    ask fixed-head-inflow-east-middle-patches
  [
    set pcolor blue set interior-node? false set fixed-head? true set no-flow? false
    set inactive-patch? false set well? false ;set H precision  (elevation - bottom-of-aquifer + inflow-H) 0
  ]
      ask fixed-head-inflow-east-above-patches
  [
    set pcolor blue set interior-node? false set fixed-head? true set no-flow? false
    set inactive-patch? false set well? false ;set H precision  (elevation - bottom-of-aquifer + inflow-H) 0
  ]

      ask fixed-head-inflow-east-below-patches
  [
    set pcolor blue set interior-node? false set fixed-head? true set no-flow? false
    set inactive-patch? false set well? false ;set H precision  (elevation - bottom-of-aquifer + inflow-H) 0
  ]


    ask fixed-head-inflow-south-patches
  [
    set pcolor blue set interior-node? false set fixed-head? true set no-flow? false
    set inactive-patch? false set well? false ;set H precision  (elevation - bottom-of-aquifer + inflow-H) 0
  ]


  ;let center-fixed-head-patch patches gis:intersecting center-fixed-head-inflow-dataset
  ask fixed-head-outflow-west-left-above-right-patches [set pcolor blue set interior-node? false set fixed-head? true set no-flow? false set inactive-patch? false set well? false]
  ask fixed-head-outflow-west-left-below-patches [set pcolor blue set interior-node? false set fixed-head? true set no-flow? false set inactive-patch? false set well? false]
  ask fixed-head-outflow-west-left-above-left-patches [set pcolor blue set interior-node? false set fixed-head? true set no-flow? false set inactive-patch? false set well? false]
  ask fixed-head-outflow-west-left-middle-patches [set pcolor blue set interior-node? false set fixed-head? true set no-flow? false set inactive-patch? false set well? false]

  ask fixed-head-outflow-east-left-above-patches [set pcolor blue set interior-node? false set fixed-head? true set no-flow? false set inactive-patch? false set well? false]
  ask fixed-head-outflow-east-left-below-patches [set pcolor blue set interior-node? false set fixed-head? true set no-flow? false set inactive-patch? false set well? false]
  ask fixed-head-outflow-east-left-middle-patches [set pcolor blue set interior-node? false set fixed-head? true set no-flow? false set inactive-patch? false set well? false]

  ask fixed-head-outflow-west-right-above-patches [set pcolor blue set interior-node? false set fixed-head? true set no-flow? false set inactive-patch? false set well? false]
  ask fixed-head-outflow-west-right-below-patches [set pcolor blue set interior-node? false set fixed-head? true set no-flow? false set inactive-patch? false set well? false]
  ask fixed-head-outflow-west-right-middle-patches [set pcolor blue set interior-node? false set fixed-head? true set no-flow? false set inactive-patch? false set well? false]

  ask fixed-head-outflow-east-right-above-patches [set pcolor blue set interior-node? false set fixed-head? true set no-flow? false set inactive-patch? false set well? false]
  ask fixed-head-outflow-east-right-below-patches [set pcolor blue set interior-node? false set fixed-head? true set no-flow? false set inactive-patch? false set well? false]

  ;let list-fixed-head-outflow-patches sort-on [patch-number-tag] fixed-head-outflow-patches
  ;foreach list-fixed-head-outflow-patches [i -> ask i [
    ;set H precision (elevation - bottom-of-aquifer +  inflow-H - (distancexy (item 0 [pxcor] of center-fixed-head-patch) (item 0 [pycor] of center-fixed-head-patch)) * delta * regional-gradient / 100) 0]]
  ask patches gis:intersecting no-flow-bc-dataset [set H 0  set pcolor black set interior-node? false set fixed-head? false set no-flow? true set inactive-patch? false set K-patch 0 set T-patch 0 set well? false  ]
  set interior-patches patches with [interior-node? = true]

    ;; wells data:

  ask interior-patches gis:intersecting Pizo-dataset  [set pcolor cyan set Pizo? true]






    ;; set list of wells and number of wells in each patch:

  ask patches gis:intersecting all-wells-dataset [ set well? true ]
  set list-of-interior-patches-with-well sort-on [patch-number-tag] interior-patches with [well? = true]
  let list-of-all-well-features gis:feature-list-of all-wells-dataset
  let x 0
  ask patches [set list-of-wells-here []]
  while [x <= length list-of-all-well-features - 1]
  [
    foreach list-of-interior-patches-with-well [j -> ask j [if (gis:intersects? j (item x list-of-all-well-features)) [ set list-of-wells-here fput (item x list-of-all-well-features) list-of-wells-here]]]
    set  x x + 1
  ]
  ask interior-patches [set number-of-wells-here length list-of-wells-here]



    ;; set flow rate of each patch m3/day:
  ask interior-patches with [well? = true][foreach list-of-wells-here [v -> set Qwell precision (Qwell + gis:property-value v "QINPUTM3DA") 2]]


    ;; set area under production

  ask interior-patches with [well? = true]
  [
    foreach list-of-wells-here [f -> set area-under-production area-under-production + gis:property-value f "AREAUP"]
  ]
  ;;; because of the discrepency between real area under production and our data we uniformly increased A in order to make it more realistic
;  ask interior-patches with [area-under-production > 0][set area-under-production area-under-production + random 40]
  scale-color-area-under-production



    ;; calculate area of monitored patches by this pizo:

  gis:apply-coverage thiessen-dataset "PIZO_NUM" Corresponding-Pizo
  let list-of-Pizo-patches sort-on  [Corresponding-Pizo] interior-patches with [Pizo? = true]
  let feature-list-of-Pizo gis:feature-list-of Pizo-dataset
  let i 0
  while [i <= length list-of-Pizo-patches - 1 ]
  [
    ask item i list-of-Pizo-patches [set area-monitored-patches-by-this-Pizo (delta ^ 2) * count interior-patches with [Corresponding-Pizo = gis:property-value item i feature-list-of-Pizo "PIZO_NUM"]]
    set i i + 1
  ]

define-fixed-heads


  ;; define anar and kerman patches for reading precipitation
   let AnarPCP-dataset gis:load-dataset "AnarPCP.shp"
   set AnarPCP-patches interior-patches gis:intersecting AnarPCP-dataset
   let KermanPCP-dataset gis:load-dataset "KermanPCP.shp"
   set KermanPCP-patches interior-patches gis:intersecting KermanPCP-dataset




  ;; calculate the model data and compare with the real data:

  let TNWells 0
  foreach list-of-interior-patches-with-well [g -> ask g [set TNWells TNWells + length list-of-wells-here]]

   print (word "Model area based on available data = " precision (count interior-patches  * (delta / 1000) ^ 2) 2" km2 "
    "and the real area based on references = 4100 km2. \n"
    "Model perimeter based on available data =" precision (count patches with [fixed-head? = true or no-flow? = true] * 1) 2 " km "
    "and the real inflow perimeter based on references = 188 km. \n "
     "total area Under Production based on available data =" precision sum [area-under-production] of interior-patches 1 " hectare "
    "and the real total area under production based on references = more than 110,000.0 hectare. \n"
     "Model number of wells based on available data =" TNWells " and the real number of wells based on references = roughly about 1434.  \n"
      )



  end

to read-real-data
  if year < 2016 [read-in-data]
        ;; set the initial heads of the interir-patches and the boundary conditions
  let o 0
  while [o < 42]
  [
    ask interior-patches with [Corresponding-Pizo = item o ok-Pizos-Num ][set real-H elevation - item o list-observed-water-tables set real-water-table item o list-observed-water-tables ]
    set o o + 1
  ]

end
to define-fixed-heads

read-real-data

  ask fixed-head-inflow-west-middle-patches
  [

    if count neighbors with [interior-node? = true] != 0
    [set H precision  (max [real-H] of neighbors with [interior-node? = true] + additional-inflow-west-middle-H ) 0]
    set K-patch K-inflow-west-middle

    set T-patch (K-patch * H)
  ]
    ask fixed-head-inflow-west-middle-patches
  [
    if count neighbors with [interior-node? = true] = 0
    [set H precision  (max [real-H] of neighbors with [fixed-head? = true] + additional-inflow-west-middle-H ) 0]
    set K-patch K-inflow-west-middle

    set T-patch (K-patch * H)

  ]
  ask fixed-head-inflow-west-below-patches
  [

    if count neighbors with [interior-node? = true] != 0
    [set H precision  (max [real-H] of neighbors with [interior-node? = true] + additional-inflow-west-below-H ) 0]
    set K-patch K-inflow-west-below

    set T-patch (K-patch * H)
  ]
    ask fixed-head-inflow-west-below-patches
  [
    if count neighbors with [interior-node? = true] = 0
    [set H precision  (max [real-H] of neighbors with [fixed-head? = true] + additional-inflow-west-below-H ) 0]
    set K-patch K-inflow-west-below

    set T-patch (K-patch * H)

  ]

  ask fixed-head-inflow-west-above-patches
  [

    if count neighbors with [interior-node? = true] != 0
    [set H precision  (max [real-H] of neighbors with [interior-node? = true] + additional-inflow-west-above-H ) 0]
    set K-patch K-inflow-west-above

    set T-patch (K-patch * H)
  ]
    ask fixed-head-inflow-west-above-patches
  [
    if count neighbors with [interior-node? = true] = 0
    [set H precision  (max [real-H] of neighbors with [fixed-head? = true] + additional-inflow-west-above-H ) 0]
    set K-patch K-inflow-west-above

    set T-patch (K-patch * H)

  ]


  ask fixed-head-inflow-south-patches
  [

    if count neighbors with [interior-node? = true] != 0
    [set H precision  (max [real-H] of neighbors with [interior-node? = true] + additional-inflow-south-H ) 0]
    set K-patch K-inflow-south

    set T-patch (K-patch * H)
  ]
    ask fixed-head-inflow-south-patches
  [
    if count neighbors with [interior-node? = true] = 0
    [set H precision  (max [real-H] of neighbors with [fixed-head? = true] + additional-inflow-south-H ) 0]
    set K-patch K-inflow-south

    set T-patch (K-patch * H)

  ]

  ask fixed-head-inflow-east-middle-patches
  [

    if count neighbors with [interior-node? = true] != 0
    [set H precision  (max [real-H] of neighbors with [interior-node? = true] + additional-inflow-east-middle-H ) 0]
    set K-patch K-inflow-east-middle

    set T-patch (K-patch * H)
  ]
    ask fixed-head-inflow-east-middle-patches
  [
    if count neighbors with [interior-node? = true] = 0
    [set H precision  (max [real-H] of neighbors with [fixed-head? = true] + additional-inflow-east-middle-H ) 0]
    set K-patch K-inflow-east-middle

    set T-patch (K-patch * H)

  ]

    ask fixed-head-inflow-east-below-patches
  [

    if count neighbors with [interior-node? = true] != 0
    [set H precision  (max [real-H] of neighbors with [interior-node? = true] + additional-inflow-east-below-H ) 0]
    set K-patch K-inflow-east-below

    set T-patch (K-patch * H)
  ]
    ask fixed-head-inflow-east-below-patches
  [
    if count neighbors with [interior-node? = true] = 0
    [set H precision  (max [real-H] of neighbors with [fixed-head? = true] + additional-inflow-east-below-H ) 0]
    set K-patch K-inflow-east-below

    set T-patch (K-patch * H)

  ]

    ask fixed-head-inflow-east-above-patches
  [

    if count neighbors with [interior-node? = true] != 0
    [set H precision  (max [real-H] of neighbors with [interior-node? = true] + additional-inflow-east-above-H ) 0]
    set K-patch K-inflow-east-above

    set T-patch (K-patch * H)
  ]
    ask fixed-head-inflow-east-above-patches
  [
    if count neighbors with [interior-node? = true] = 0
    [set H precision  (max [real-H] of neighbors with [fixed-head? = true] + additional-inflow-east-above-H ) 0]
    set K-patch K-inflow-east-above

    set T-patch (K-patch * H)

  ]

   ;let center-fixed-head-patch patches gis:intersecting center-fixed-head-inflow-dataset
   ask fixed-head-outflow-west-right-above-patches
  [

    if count neighbors with [interior-node? = true] != 0
    [set H precision  (max [real-H] of neighbors with [interior-node? = true] - subtract-outflow-west-right-above-H ) 0]
    set K-patch K-outflow-west-right-above

    set T-patch (K-patch * H)

  ]



      ask fixed-head-outflow-west-right-above-patches
  [
    if count neighbors with [interior-node? = true] = 0
    [set H precision  (max [real-H] of neighbors with [fixed-head? = true] - subtract-outflow-west-right-above-H ) 0]
    set K-patch K-outflow-west-right-above

    set T-patch (K-patch * H)


  ]

     ask fixed-head-outflow-west-right-middle-patches
  [

    if count neighbors with [interior-node? = true] != 0
    [set H precision  (max [real-H] of neighbors with [interior-node? = true] - subtract-outflow-west-right-middle-H ) 0]
    set K-patch K-outflow-west-right-middle

    set T-patch (K-patch * H)

  ]



      ask fixed-head-outflow-west-right-middle-patches
  [
    if count neighbors with [interior-node? = true] = 0
    [set H precision  (max [real-H] of neighbors with [fixed-head? = true] - subtract-outflow-west-right-middle-H ) 0]
    set K-patch K-outflow-west-right-middle

    set T-patch (K-patch * H)


  ]
     ask fixed-head-outflow-west-right-below-patches
  [

    if count neighbors with [interior-node? = true] != 0
    [set H precision  (max [real-H] of neighbors with [interior-node? = true] - subtract-outflow-west-right-below-H ) 0]
    set K-patch K-outflow-west-right-below

    set T-patch (K-patch * H)

  ]



      ask fixed-head-outflow-west-right-below-patches
  [
    if count neighbors with [interior-node? = true] = 0
    [set H precision  (max [real-H] of neighbors with [fixed-head? = true] - subtract-outflow-west-right-below-H ) 0]
    set K-patch K-outflow-west-right-below

    set T-patch (K-patch * H)


  ]

       ask fixed-head-outflow-west-left-above-right-patches
  [

    if count neighbors with [interior-node? = true] != 0
    [set H precision  (max [real-H] of neighbors with [interior-node? = true] - subtract-outflow-west-left-above-H-right ) 0]
    set K-patch K-outflow-west-left-above-right

    set T-patch (K-patch * H)

  ]


        ask fixed-head-outflow-west-left-above-right-patches
  [
    if count neighbors with [interior-node? = true] = 0
    [set H precision  (max [real-H] of neighbors with [fixed-head? = true] - subtract-outflow-west-left-above-H-right ) 0]
    set K-patch K-outflow-west-left-above-right

    set T-patch (K-patch * H)


  ]

         ask fixed-head-outflow-west-left-above-left-patches
  [

    if count neighbors with [interior-node? = true] != 0
    [set H precision  (max [real-H] of neighbors with [interior-node? = true] - subtract-outflow-west-left-above-H-left ) 0]
    set K-patch K-outflow-west-left-above-left

    set T-patch (K-patch * H)

  ]


        ask fixed-head-outflow-west-left-above-left-patches
  [
    if count neighbors with [interior-node? = true] = 0
    [set H precision  (max [real-H] of neighbors with [fixed-head? = true] - subtract-outflow-west-left-above-H-left ) 0]
    set K-patch K-outflow-west-left-above-left

    set T-patch (K-patch * H)


  ]

         ask fixed-head-outflow-west-left-middle-patches
  [

    if count neighbors with [interior-node? = true] != 0
    [set H precision  (max [real-H] of neighbors with [interior-node? = true] - subtract-outflow-west-left-middle-H ) 0]
    set K-patch K-outflow-west-left-middle

    set T-patch (K-patch * H)

  ]


        ask fixed-head-outflow-west-left-middle-patches
  [
    if count neighbors with [interior-node? = true] = 0
    [set H precision  (max [real-H] of neighbors with [fixed-head? = true] - subtract-outflow-west-left-middle-H ) 0]
    set K-patch K-outflow-west-left-middle

    set T-patch (K-patch * H)


  ]


         ask fixed-head-outflow-west-left-below-patches
  [

    if count neighbors with [interior-node? = true] != 0
    [set H precision  (max [real-H] of neighbors with [interior-node? = true] - subtract-outflow-west-left-below-H ) 0]
    set K-patch K-outflow-west-left-below

    set T-patch (K-patch * H)

  ]



   ask fixed-head-outflow-east-left-middle-patches
  [

    if count neighbors with [interior-node? = true] != 0
    [set H precision  (max [real-H] of neighbors with [interior-node? = true] - subtract-outflow-east-left-middle-H ) 0]
    set K-patch K-outflow-east-left-middle

    set T-patch (K-patch * H)

  ]

      ask fixed-head-outflow-east-left-middle-patches
  [
    if count neighbors with [interior-node? = true] = 0
    [set H precision  (max [real-H] of neighbors with [fixed-head? = true] - subtract-outflow-east-left-middle-H ) 0]
    set K-patch K-outflow-east-left-middle

    set T-patch (K-patch * H)

  ]

     ask fixed-head-outflow-east-left-below-patches
  [

    if count neighbors with [interior-node? = true] != 0
    [set H precision  (max [real-H] of neighbors with [interior-node? = true] - subtract-outflow-east-left-below-H ) 0]
    set K-patch K-outflow-east-left-below

    set T-patch (K-patch * H)

  ]

      ask fixed-head-outflow-east-left-below-patches
  [
    if count neighbors with [interior-node? = true] = 0
    [set H precision  (max [real-H] of neighbors with [fixed-head? = true] - subtract-outflow-east-left-below-H ) 0]
    set K-patch K-outflow-east-left-below

    set T-patch (K-patch * H)

  ]

     ask fixed-head-outflow-east-left-above-patches
  [

    if count neighbors with [interior-node? = true] != 0
    [set H precision  (max [real-H] of neighbors with [interior-node? = true] - subtract-outflow-east-left-above-H ) 0]
    set K-patch K-outflow-east-left-above

    set T-patch (K-patch * H)

  ]

      ask fixed-head-outflow-east-left-above-patches
  [
    if count neighbors with [interior-node? = true] = 0
    [set H precision  (max [real-H] of neighbors with [fixed-head? = true] - subtract-outflow-east-left-above-H ) 0]
    set K-patch K-outflow-east-left-above

    set T-patch (K-patch * H)

  ]

     ask fixed-head-outflow-east-right-below-patches
  [

    if count neighbors with [interior-node? = true] != 0
    [set H precision  (max [real-H] of neighbors with [interior-node? = true] - subtract-outflow-east-right-below-H ) 0]
    set K-patch K-outflow-east-right-below

    set T-patch (K-patch * H)

  ]

      ask fixed-head-outflow-east-right-below-patches
  [
    if count neighbors with [interior-node? = true] = 0
    [set H precision  (max [real-H] of neighbors with [fixed-head? = true] - subtract-outflow-east-right-below-H ) 0]
    set K-patch K-outflow-east-right-below

    set T-patch (K-patch * H)

  ]

       ask fixed-head-outflow-east-right-above-patches
  [

    if count neighbors with [interior-node? = true] != 0
    [set H precision  (max [real-H] of neighbors with [interior-node? = true] - subtract-outflow-east-right-above-H ) 0]
    set K-patch K-outflow-east-right-above

    set T-patch (K-patch * H)

  ]

      ask fixed-head-outflow-east-right-above-patches
  [
    if count neighbors with [interior-node? = true] = 0
    [set H precision  (max [real-H] of neighbors with [fixed-head? = true] - subtract-outflow-east-right-above-H ) 0]
    set K-patch K-outflow-east-right-above

    set T-patch (K-patch * H)

  ]
end

to initial-water-table
    let o 0
  while [o < 42]
  [
    ask interior-patches with [Corresponding-Pizo = item o ok-Pizos-Num ][set H elevation - item o list-observed-water-tables set real-water-table item o list-observed-water-tables set water-table real-water-table]
    set o o + 1
  ]
end

to scale-color-elevation
  let color-max max [elevation] of patches with [elevation > 0]
  let color-min min [elevation] of patches with [elevation > 0]
  ask patches [if (elevation > 0) [set pcolor scale-color 35 elevation (color-min ) color-max ]]
end

to scale-color-area-under-production
  let area-max max [area-under-production] of interior-patches with [area-under-production > 0]
  let area-min min [area-under-production] of interior-patches with [area-under-production > 0]
  ask interior-patches with [well? = true][if (area-under-production > 0) [set pcolor scale-color 55 area-under-production (area-max - 20) area-min]]
end

to scale-color-Qwell
  let Qwell-max max [Qwell] of interior-patches with [Qwell >= 0]
  let Qwell-min min [Qwell] of interior-patches with [Qwell >= 0]
  ask interior-patches with [well? = true][if (Qwell >= 0) [set pcolor scale-color red Qwell Qwell-max Qwell-min]]
end

to scale-color-water-table
  let water-table-max max [water-table] of interior-patches
  let water-table-min min [water-table] of interior-patches
  ask interior-patches [set pcolor scale-color cyan water-table water-table-max water-table-min]
end

to scale-color-heads

  let H-max max [H] of interior-patches
  let H-min min [H] of interior-patches
  ask interior-patches [set pcolor scale-color red H H-max H-min]
end

to scale-color-recharge

  let recharge-max max [Recharge] of interior-patches
  let recharge-min min [Recharge] of interior-patches
  ask interior-patches [set pcolor scale-color blue Recharge (recharge-max + 0.00005) recharge-min]
end

to scale-color-UsageOfTheWells
  ask patches [set plabel ""]
  let only-farmerwells-patches interior-patches with [well? = true and number-of-Farmer-wells-here > 0 and number-of-Industry-wells-here = 0 and number-of-Domestic-wells-here = 0]
  let only-Industrywels-patches interior-patches with [well? = true and number-of-Farmer-wells-here = 0 and number-of-Industry-wells-here > 0 and number-of-Domestic-wells-here = 0]
  let only-DomesticWells-patches interior-patches with [well? = true and number-of-Farmer-wells-here = 0 and number-of-Industry-wells-here = 0 and number-of-Domestic-wells-here > 0]
  let common-wells-patches interior-patches with [well? = true and ((number-of-Farmer-wells-here > 0 and number-of-Industry-wells-here > 0 and number-of-Domestic-wells-here = 0) or
    (number-of-Farmer-wells-here > 0 and number-of-Industry-wells-here = 0 and  number-of-Domestic-wells-here > 0) or
    (number-of-Farmer-wells-here = 0 and number-of-Industry-wells-here > 0 and number-of-Domestic-wells-here > 0))]


  let Qwellfarmer-max max [Qwell-Farmer] of only-farmerwells-patches
  let Qwellfarmer-min min [Qwell-Farmer] of only-farmerwells-patches
  ask only-farmerwells-patches [set pcolor scale-color green Qwell-Farmer Qwellfarmer-max Qwellfarmer-min set plabel "F" set plabel-color black ]

  let QwellIndustryAgent-max max [Qwell-Industry] of only-Industrywels-patches
  let QwellIndustryAgent-min min [Qwell-Industry] of only-Industrywels-patches
  ask only-Industrywels-patches [set pcolor scale-color orange Qwell-Industry (QwellIndustryAgent-max ) QwellIndustryAgent-min set plabel "I" set plabel-color black ]

  let QwellDomesticAgent-max max [Qwell-Domestic] of only-DomesticWells-patches
  let QwellDomesticAgent-min min [Qwell-Domestic] of only-DomesticWells-patches
  ask only-DomesticWells-patches [set pcolor scale-color cyan Qwell-Domestic (QwellDomesticAgent-max   ) QwellDomesticAgent-min set plabel "D" set plabel-color black ]

  let QwellCommon-max max [Qwell] of common-wells-patches
  let QwellCommon-min min [Qwell] of common-wells-patches
  ask common-wells-patches [set pcolor scale-color violet Qwell (QwellCommon-max ) QwellCommon-min set plabel "M" set plabel-color black ]
end





to setup-hydrolic-parameters

  ask interior-patches with [Corresponding-Pizo = 3 and no-flow? = false and inactive-patch? = false] [set K-patch K3 set T-patch (K-patch * H) set S-patch Sy3]
  ask interior-patches with [Corresponding-Pizo = 4 and no-flow? = false and inactive-patch? = false] [set K-patch K4 set T-patch (K-patch * H) set S-patch Sy4]
  ask interior-patches with [Corresponding-Pizo = 7 and no-flow? = false and inactive-patch? = false] [set K-patch K7 set T-patch (K-patch * H) set S-patch Sy7]
  ask interior-patches with [Corresponding-Pizo = 8 and no-flow? = false and inactive-patch? = false] [set K-patch K8 set T-patch (K-patch * H) set S-patch Sy8]
  ask interior-patches with [Corresponding-Pizo = 9 and no-flow? = false and inactive-patch? = false] [set K-patch K9 set T-patch (K-patch * H) set S-patch Sy9]
  ask interior-patches with [Corresponding-Pizo = 10 and no-flow? = false and inactive-patch? = false] [set K-patch K10 set T-patch (K-patch * H) set S-patch Sy10]
  ask interior-patches with [Corresponding-Pizo = 11 and no-flow? = false and inactive-patch? = false] [set K-patch K11 set T-patch (K-patch * H) set S-patch Sy11]
  ask interior-patches with [Corresponding-Pizo = 13 and no-flow? = false and inactive-patch? = false] [set K-patch K13 set T-patch (K-patch * H) set S-patch Sy13]
  ask interior-patches with [Corresponding-Pizo = 14 and no-flow? = false and inactive-patch? = false] [set K-patch K14 set T-patch (K-patch * H) set S-patch Sy14]
  ask interior-patches with [Corresponding-Pizo = 15 and no-flow? = false and inactive-patch? = false] [set K-patch K15 set T-patch (K-patch * H) set S-patch Sy15]
  ask interior-patches with [Corresponding-Pizo = 19 and no-flow? = false and inactive-patch? = false] [set K-patch K19 set T-patch (K-patch * H) set S-patch Sy19]
  ask interior-patches with [Corresponding-Pizo = 20 and no-flow? = false and inactive-patch? = false] [set K-patch K20 set T-patch (K-patch * H) set S-patch Sy20]
  ask interior-patches with [Corresponding-Pizo = 24 and no-flow? = false and inactive-patch? = false] [set K-patch K24 set T-patch (K-patch * H) set S-patch Sy24]
  ask interior-patches with [Corresponding-Pizo = 26 and no-flow? = false and inactive-patch? = false] [set K-patch K26 set T-patch (K-patch * H) set S-patch Sy26]
  ask interior-patches with [Corresponding-Pizo = 31 and no-flow? = false and inactive-patch? = false] [set K-patch K31 set T-patch (K-patch * H) set S-patch Sy31]
  ask interior-patches with [Corresponding-Pizo = 33 and no-flow? = false and inactive-patch? = false] [set K-patch K33 set T-patch (K-patch * H) set S-patch Sy33]
  ask interior-patches with [Corresponding-Pizo = 34 and no-flow? = false and inactive-patch? = false] [set K-patch K34 set T-patch (K-patch * H) set S-patch Sy34]
  ask interior-patches with [Corresponding-Pizo = 38 and no-flow? = false and inactive-patch? = false] [set K-patch K38 set T-patch (K-patch * H) set S-patch Sy38]
  ask interior-patches with [Corresponding-Pizo = 39 and no-flow? = false and inactive-patch? = false] [set K-patch K39 set T-patch (K-patch * H) set S-patch Sy39]
  ask interior-patches with [Corresponding-Pizo = 43 and no-flow? = false and inactive-patch? = false] [set K-patch K43 set T-patch (K-patch * H) set S-patch Sy43]
  ask interior-patches with [Corresponding-Pizo = 44 and no-flow? = false and inactive-patch? = false] [set K-patch K44 set T-patch (K-patch * H) set S-patch Sy44]
  ask interior-patches with [Corresponding-Pizo = 49 and no-flow? = false and inactive-patch? = false] [set K-patch K49 set T-patch (K-patch * H) set S-patch Sy49]
  ask interior-patches with [Corresponding-Pizo = 50 and no-flow? = false and inactive-patch? = false] [set K-patch K50 set T-patch (K-patch * H) set S-patch Sy50]
  ask interior-patches with [Corresponding-Pizo = 51 and no-flow? = false and inactive-patch? = false] [set K-patch K51 set T-patch (K-patch * H) set S-patch Sy51]
  ask interior-patches with [Corresponding-Pizo = 53 and no-flow? = false and inactive-patch? = false] [set K-patch K53 set T-patch (K-patch * H) set S-patch Sy53]
  ask interior-patches with [Corresponding-Pizo = 56 and no-flow? = false and inactive-patch? = false] [set K-patch K56 set T-patch (K-patch * H) set S-patch Sy56]
  ask interior-patches with [Corresponding-Pizo = 58 and no-flow? = false and inactive-patch? = false] [set K-patch K58 set T-patch (K-patch * H) set S-patch Sy58]
  ask interior-patches with [Corresponding-Pizo = 59 and no-flow? = false and inactive-patch? = false] [set K-patch K59 set T-patch (K-patch * H) set S-patch Sy59]
  ask interior-patches with [Corresponding-Pizo = 60 and no-flow? = false and inactive-patch? = false] [set K-patch K60 set T-patch (K-patch * H) set S-patch Sy60]
  ask interior-patches with [Corresponding-Pizo = 63 and no-flow? = false and inactive-patch? = false] [set K-patch K63 set T-patch (K-patch * H) set S-patch Sy63]
  ask interior-patches with [Corresponding-Pizo = 65 and no-flow? = false and inactive-patch? = false] [set K-patch K65 set T-patch (K-patch * H) set S-patch Sy65]
  ask interior-patches with [Corresponding-Pizo = 66 and no-flow? = false and inactive-patch? = false] [set K-patch K66 set T-patch (K-patch * H) set S-patch Sy66]
  ask interior-patches with [Corresponding-Pizo = 69 and no-flow? = false and inactive-patch? = false] [set K-patch K69 set T-patch (K-patch * H) set S-patch Sy69]
  ask interior-patches with [Corresponding-Pizo = 70 and no-flow? = false and inactive-patch? = false] [set K-patch K70 set T-patch (K-patch * H) set S-patch Sy70]
  ask interior-patches with [Corresponding-Pizo = 72 and no-flow? = false and inactive-patch? = false] [set K-patch K72 set T-patch (K-patch * H) set S-patch Sy72]
  ask interior-patches with [Corresponding-Pizo = 74 and no-flow? = false and inactive-patch? = false] [set K-patch K74 set T-patch (K-patch * H) set S-patch Sy74]
  ask interior-patches with [Corresponding-Pizo = 76 and no-flow? = false and inactive-patch? = false] [set K-patch K76 set T-patch (K-patch * H) set S-patch Sy76]
  ask interior-patches with [Corresponding-Pizo = 77 and no-flow? = false and inactive-patch? = false] [set K-patch K77 set T-patch (K-patch * H) set S-patch Sy77]
  ask interior-patches with [Corresponding-Pizo = 79 and no-flow? = false and inactive-patch? = false] [set K-patch K79 set T-patch (K-patch * H) set S-patch Sy79]
  ask interior-patches with [Corresponding-Pizo = 80 and no-flow? = false and inactive-patch? = false] [set K-patch K80 set T-patch (K-patch * H) set S-patch Sy80]
  ask interior-patches with [Corresponding-Pizo = 81 and no-flow? = false and inactive-patch? = false] [set K-patch K81 set T-patch (K-patch * H) set S-patch Sy81]
  ask interior-patches with [Corresponding-Pizo = 82 and no-flow? = false and inactive-patch? = false] [set K-patch K82 set T-patch (K-patch * H) set S-patch Sy82]
  ask patches  with [fixed-head? = true  ] [set S-patch Sy set T-patch K-patch * H]
  ;ask interior-patches [set S-patch 0.205]
end

to setup-sources
  ask interior-patches [set recharge? true set Recharge 5E-5]
end

to setup-neighbours
  ask interior-patches
  [
    set N-neighbour patch-at 0 1
    set S-neighbour patch-at 0 -1
    set W-neighbour patch-at  -1 0
    set E-neighbour patch-at 1 0
  ]
end

to setup-patch-numbering
  let DEM-dataset gis:load-dataset  "extent.asc"
  let Y (gis:height-of DEM-dataset )
  let PNRows 0
  while [Y > 0]
  [

    let NRows count interior-patches with [pycor = Y ]
    let NRows-patches interior-patches with [pycor = Y ]
    let NRows-patches-list sort-on [pxcor] NRows-patches
    let i 1
      foreach NRows-patches-list [x -> ask x [set patch-number-tag (PNRows + i) set plabel-color black set plabel patch-number-tag ] set i i + 1 ]


    set Y Y - 1
    set PNRows PNRows + NRows
  ]
  ask patches with [inactive-patch? = true][set patch-number-tag -2]
  ask patches with [no-flow? = true or fixed-head? = true][set patch-number-tag -1]
end

to setup-patches-adjacent-to-boundary
  ask interior-patches
  [
    ifelse [no-flow?] of N-neighbour or [no-flow?] of S-neighbour or [no-flow?] of E-neighbour or [no-flow?] of W-neighbour or [fixed-head?] of N-neighbour or
    [fixed-head?] of S-neighbour or [fixed-head?] of E-neighbour or [fixed-head?] of W-neighbour [set adjacent-to-boundary? true][set adjacent-to-boundary? false]
  ]
  ask interior-patches[set top-right-corner? false set top-left-corner? false set bottom-right-corner? false set bottom-left-corner? false set top-row? false set bottom-row? false set right-column? false set left-column? false]
  ask interior-patches with [adjacent-to-boundary? = true]
  [
    if [patch-number-tag] of N-neighbour = -1 and [patch-number-tag] of E-neighbour = -1 [set top-right-corner? true set W-peninsula? false set E-peninsula? false set S-peninsula? false set N-peninsula? false]
    if [patch-number-tag] of N-neighbour = -1 and [patch-number-tag] of W-neighbour = -1 [set top-left-corner? true set W-peninsula? false set E-peninsula? false set S-peninsula? false set N-peninsula? false]
    if [patch-number-tag] of S-neighbour = -1 and [patch-number-tag] of E-neighbour = -1 [set bottom-right-corner? true set W-peninsula? false set E-peninsula? false set S-peninsula? false set N-peninsula? false]
    if [patch-number-tag] of S-neighbour = -1 and [patch-number-tag] of W-neighbour = -1 [set bottom-left-corner? true set W-peninsula? false set E-peninsula? false set S-peninsula? false set N-peninsula? false]
    if [patch-number-tag] of N-neighbour = -1 and [patch-number-tag] of E-neighbour != -1 and [patch-number-tag] of W-neighbour != -1 [set top-row? true ]
    if [patch-number-tag] of S-neighbour = -1 and [patch-number-tag] of E-neighbour != -1 and [patch-number-tag] of W-neighbour != -1 [set bottom-row? true ]
    if [patch-number-tag] of E-neighbour = -1 and [patch-number-tag] of N-neighbour != -1 and [patch-number-tag] of S-neighbour != -1 [set right-column? true ]
    if [patch-number-tag] of W-neighbour = -1 and [patch-number-tag] of N-neighbour != -1 and [patch-number-tag] of S-neighbour != -1 [set left-column? true ]
    if ([patch-number-tag] of N-neighbour = -1 and [patch-number-tag] of W-neighbour = -1 and [patch-number-tag] of E-neighbour = -1)[set S-peninsula? true set top-right-corner? false set top-left-corner? false set bottom-right-corner? false set bottom-left-corner? false]
    if ([patch-number-tag] of N-neighbour = -1 and [patch-number-tag] of W-neighbour = -1 and [patch-number-tag] of S-neighbour = -1)[set E-peninsula? true set top-right-corner? false set top-left-corner? false set bottom-right-corner? false set bottom-left-corner? false]
    if ([patch-number-tag] of S-neighbour = -1 and [patch-number-tag] of W-neighbour = -1 and [patch-number-tag] of E-neighbour = -1)[set N-peninsula? true set top-right-corner? false set top-left-corner? false set bottom-right-corner? false set bottom-left-corner? false]
    if ([patch-number-tag] of N-neighbour = -1 and [patch-number-tag] of S-neighbour = -1 and [patch-number-tag] of E-neighbour = -1)[set W-peninsula? true set top-right-corner? false set top-left-corner? false set bottom-right-corner? false set bottom-left-corner? false]
    ]
end

to refresh-view
  if view = "patch numbering" [scale-color-elevation view-bc ask interior-patches [ set pcolor white set plabel precision patch-number-tag 1 set plabel-color black]]
  if view = "wells" [scale-color-elevation view-bc scale-color-area-under-production ask interior-patches [set plabel "" ] ask interior-patches with [well? = true][set plabel "W" ifelse (area-under-production > 0) [set plabel-color black][set plabel-color 135 ]]  ask interior-patches with [Pizo? = true] [ set plabel-color black set plabel "P" set pcolor cyan] ]
  if view = "K (contours)" [scale-color-elevation view-bc setup-maxmin-K ask interior-patches [set pcolor scale-color brown K-patch min-K max-K set plabel precision K-patch 0 set plabel-color black] ask patches with [no-flow? = true][set pcolor black]]
  if view = "Water Table (contours)" [setup-maxmin-heads view-bc scale-color-water-table  ask interior-patches[set plabel "" ]]
  if view = "Heads (contours)" [setup-maxmin-heads view-bc scale-color-heads  ask interior-patches[set plabel "" ]]

  if view = "recharge" [scale-color-elevation view-bc scale-color-recharge ]
  if view = "Qwell m3/day" [scale-color-elevation view-bc ask interior-patches [set plabel "" ] ask interior-patches with [well? = true][scale-color-Qwell]]
  if view = "area covered by pizo km2" [scale-color-elevation view-bc ask interior-patches[set plabel "" set pcolor Corresponding-Pizo set plabel ""] ask interior-patches with [Pizo? = true][ set plabel precision (area-monitored-patches-by-this-Pizo / 10 ^ 6) 0 ifelse (remainder Corresponding-Pizo 10 = 0 or remainder Corresponding-Pizo 10 = 1) [set plabel-color 16][set plabel-color black]]]
  if view = "usage of the wells" [scale-color-elevation view-bc scale-color-UsageOfTheWells]
  if view = "all the time transactions" [scale-color-elevation view-bc all-time-transactions ]
  if view = "this year transactions" [scale-color-elevation view-bc this-year-transactions ]
  if view = "agents' farms" [scale-color-elevation view-bc scale-color-agents'-farms ask interior-patches [set plabel "" ]]

end

to view-bc
  ask patches with [no-flow? = true][set pcolor black set plabel ""set plabel-color red]
  ask patches with [fixed-head? = true][set pcolor blue set plabel "" set plabel-color black]
end

to setup-maxmin-K                                                        ;; finds max and min K values for colour-coding
  set max-K [K-patch] of max-one-of patches [K-patch]
  set min-K [K-patch] of min-one-of patches [K-patch]
end

to setup-maxmin-heads
  set max-head [H] of max-one-of interior-patches [H]
  set min-head [H] of min-one-of interior-patches [H]
end



to prepare-equations
  calculate-conductances
  modify-conductances-for-bcs
  build-matrix-A
  calculate-inverse-A
end

to calculate-conductances
  ask patches with [interior-node? = true]
  [
    set TN [T-patch] of N-neighbour
    set TS [T-patch] of S-neighbour
    set TW [T-patch] of W-neighbour
    set TE [T-patch] of E-neighbour
    set TC [T-patch] of self


    set Ncof  (1 / (delta ^ 2)) * (2 * TN * TC) / (TN + TC)
    set Scof  (1 / (delta ^ 2)) * (2 * TS * TC) / (TS + TC)
    set Wcof  (1 / (delta ^ 2)) * (2 * TW * TC) / (TW + TC)
    set Ecof  (1 / (delta ^ 2)) * (2 * TE * TC) / (TE + TC)
    set Ccof  -1 * (Ncof + Scof + Wcof + Ecof + S-patch / delta-t)
  ]
end

to modify-conductances-for-bcs
  ask interior-patches with [adjacent-to-boundary? = true]
  [
    if [no-flow?] of N-neighbour = true [set Ncof 0]
    if [no-flow?] of S-neighbour = true [set Scof 0]
    if [no-flow?] of E-neighbour = true [set Ecof 0]
    if [no-flow?] of W-neighbour = true [set Wcof 0]
    set Ccof  -1 * (Ncof + Scof + Wcof + Ecof + S-patch / delta-t)
  ]
end

to build-matrix-A
  set number-of-unknowns count interior-patches
  set A matrix:make-constant number-of-unknowns number-of-unknowns 0


  ask interior-patches with [adjacent-to-boundary? = false]
  [
    let my-position [patch-number-tag] of self - 1
    matrix:set A my-position (my-position) [Ccof] of self
    matrix:set A my-position ([patch-number-tag] of E-neighbour - 1) [Ecof] of self
    matrix:set A my-position ([patch-number-tag] of W-neighbour - 1) [Wcof] of self
    matrix:set A my-position ([patch-number-tag] of N-neighbour - 1) [Ncof] of self
    matrix:set A my-position ([patch-number-tag] of S-neighbour - 1) [Scof] of self
  ]


  ask interior-patches with [top-right-corner? = true]
  [
    let my-position ([patch-number-tag] of self - 1)
    matrix:set A my-position my-position [Ccof] of self
    matrix:set A my-position ([patch-number-tag] of W-neighbour - 1) [Wcof] of self
    matrix:set A my-position ([patch-number-tag] of S-neighbour - 1) [Scof] of self
  ]

    ask interior-patches with [top-left-corner? = true]
  [
    let my-position ([patch-number-tag] of self - 1)
    matrix:set A my-position my-position [Ccof] of self
    matrix:set A my-position ([patch-number-tag] of E-neighbour - 1) [Ecof] of self
    matrix:set A my-position ([patch-number-tag] of S-neighbour - 1) [Scof] of self
  ]
   ask interior-patches with [bottom-right-corner? = true]
  [
    let my-position ([patch-number-tag] of self - 1)
    matrix:set A my-position my-position [Ccof] of self
    matrix:set A my-position ([patch-number-tag] of W-neighbour - 1) [Wcof] of self
    matrix:set A my-position ([patch-number-tag] of N-neighbour - 1) [Ncof] of self
  ]

   ask interior-patches with [bottom-left-corner? = true]
  [
    let my-position ([patch-number-tag] of self - 1)
    matrix:set A my-position my-position [Ccof] of self
    matrix:set A my-position ([patch-number-tag] of E-neighbour - 1) [Ecof] of self
    matrix:set A my-position ([patch-number-tag] of N-neighbour - 1) [Ncof] of self
  ]
   ask interior-patches with [top-row? = true]
  [
    let my-position ([patch-number-tag] of self - 1)
    matrix:set A my-position my-position [Ccof] of self
    matrix:set A my-position ([patch-number-tag] of E-neighbour - 1) [Ecof] of self
    matrix:set A my-position ([patch-number-tag] of W-neighbour - 1) [Wcof] of self
    matrix:set A my-position ([patch-number-tag] of S-neighbour - 1) [Scof] of self
  ]
  ask interior-patches with [bottom-row? = true]
  [
    let my-position ([patch-number-tag] of self - 1)
    matrix:set A my-position my-position [Ccof] of self
    matrix:set A my-position ([patch-number-tag] of E-neighbour - 1) [Ecof] of self
    matrix:set A my-position ([patch-number-tag] of W-neighbour - 1) [Wcof] of self
    matrix:set A my-position ([patch-number-tag] of N-neighbour - 1) [Ncof] of self
  ]
  ask interior-patches with [right-column? = true]
  [
    let my-position ([patch-number-tag] of self - 1)
    matrix:set A my-position my-position [Ccof] of self
    matrix:set A my-position ([patch-number-tag] of S-neighbour - 1) [Scof] of self
    matrix:set A my-position ([patch-number-tag] of W-neighbour - 1) [Wcof] of self
    matrix:set A my-position ([patch-number-tag] of N-neighbour - 1) [Ncof] of self
  ]
  ask interior-patches with [left-column? = true]
  [
    let my-position ([patch-number-tag] of self - 1)
    matrix:set A my-position my-position [Ccof] of self
    matrix:set A my-position ([patch-number-tag] of E-neighbour - 1) [Ecof] of self
    matrix:set A my-position ([patch-number-tag] of S-neighbour - 1) [Scof] of self
    matrix:set A my-position ([patch-number-tag] of N-neighbour - 1) [Ncof] of self
  ]

  ask interior-patches with [E-peninsula? = true]
  [
    let my-position ([patch-number-tag] of self - 1)
    matrix:set A my-position my-position [Ccof] of self
    matrix:set A my-position ([patch-number-tag] of E-neighbour - 1) [Ecof] of self
  ]

  ask interior-patches with [W-peninsula? = true]
  [
    let my-position ([patch-number-tag] of self - 1)
    matrix:set A my-position my-position [Ccof] of self
    matrix:set A my-position ([patch-number-tag] of W-neighbour - 1) [Ecof] of self
  ]


ask interior-patches with [S-peninsula? = true]
[
    let my-position ([patch-number-tag] of self - 1)
    matrix:set A my-position my-position [Ccof] of self
    matrix:set A my-position ([patch-number-tag] of S-neighbour - 1) [Ecof] of self
  ]

  ask interior-patches with [N-peninsula? = true]
  [
    let my-position ([patch-number-tag] of self - 1)
    matrix:set A my-position my-position [Ccof] of self
    matrix:set A my-position ([patch-number-tag] of N-neighbour - 1) [Ecof] of self
  ]
end

to calculate-inverse-A
  set inverse-A matrix:inverse A

end

to solve-once
  calculate-source-term                       ;; comprises the sources (wells, ET) and sinks (injection, recharge)
  calculate-RHS                               ;; obtain the RHS of each equation
  build-matrix-C                              ;; these only need to be calculated at the beggining of each iteration
  solve-system-of-equations                   ;; solve the system of equations AxB=C
  list-of-active-cells                        ;; lists the cells to be updated with new heads
  extract-Hinew                               ;; the new heads are mapped into the Hinew variable of the grid
  update-heads-to-grid                        ;; H <-- Hinew / the iteration has ended so we update the H values for the iterations corresponding to the next timestep
end

to calculate-source-term




  ask interior-patches
  [

    ;set SourceTerm ((Qwell - Qinjection) / (delta ^ 2)) + (- Recharge ) + (ET) + (DRAIN / (delta ^ 2)) + (RIV / (delta ^ 2))      ;; units consistent [L3/L2*T] ~ [L/T]
    set SourceTerm ((Qwell) / (delta ^ 2)) + (- Recharge )      ;; units consistent [L3/L2*T] ~ [L/T]

    ;; look at neighbours for fixed-head boundary, we know the heads here and therefore move this term to the RHS
    if [fixed-head?] of N-neighbour = true [set SourceTerm (SourceTerm - ([H] of N-neighbour) * (Ncof))]
    if [fixed-head?] of S-neighbour = true [set SourceTerm (SourceTerm - ([H] of S-neighbour) * (Scof))]
    if [fixed-head?] of E-neighbour = true [set SourceTerm (SourceTerm - ([H] of E-neighbour) * (Ecof))]
    if [fixed-head?] of W-neighbour = true [set SourceTerm (SourceTerm - ([H] of W-neighbour) * (Wcof))]
  ]
end

to calculate-RHS
  ask interior-patches
  [set RHS (-1 * S-patch) / delta-t * (H) + SourceTerm]
end

to build-matrix-C
  set C matrix:make-constant number-of-unknowns 1 0
  ask interior-patches
  [
    let my-position ([patch-number-tag] of self - 1)
    matrix:set C my-position 0 [RHS] of self
  ]
end

to solve-system-of-equations
  set solution-vector matrix:times inverse-A C

end




to list-of-active-cells
  set active-cells-remap (list [patch-number-tag] of interior-patches with [no-flow? = false and fixed-head? = false])
  set active-cells-remap sort item 0 active-cells-remap
end

to extract-Hinew
  let i 0
  while [i <= length active-cells-remap - 1]
  [
    ask interior-patches with [patch-number-tag = (item i active-cells-remap)][set Hinew precision (matrix:get (solution-vector) i 0) 2]
    set i i + 1
  ]
end

to update-heads-to-grid
  ask interior-patches with [no-flow? = false and fixed-head? = false][set H precision Hinew 2 set water-table precision (elevation - H) 2] ;(elevation-from-bottom-of-aquifer - H) 2]                    ;; replace the old head value with the new one
  ask Farmers [set Farmer-farm-water-table mean [water-table] of Farmer-patches]
end

to go-GroundWater

  if delta-t = 365 [calculate-yearly-Recharge]
  if delta-t = 30 [calculate-monthly-Recharge]
  ask interior-patches [set Hinitial H]
  ask interior-patches with [area-under-production > 0][set ID (1000 - Precipitation) * area-under-production / 100 ]         ;; ML/year
  ask Farmers [let i 0 ask Farmer-patches[set i i + ID] set Farmer-ID i]
  CALCULATE-TProfit
  UPDATE-LORENZ-AND-GINI
  iterate
  calculate-H-unit-hydrograph

  tick
  if delta-t = 365 [set year year + 1]
  if delta-t = 30 [if ticks = 12 [reset-ticks calculate-month set year year + 1]]
  ask interior-patches [set Drawdown-from-Mehr (Hinitial - H)]
  calculate-Farmer-WaterUsage
  set model-ready? true

end

to iterate
   ifelse Changing-Boundary? = true
 [
    if year > 2003
[
   ; read-in-data
  ;  define-fixed-heads
  ;  if ready-to-change-fixed-heads-datum? = true
  ;  [
   ;   ask patches with [fixed-head? = true][set bottom-from-see elevation - 750 set elevation-from-bottom-of-aquifer elevation - bottom-from-see set H H - bottom-from-see  ]
  ;  ]
      read-real-data
      ask patches with [fixed-head? = true][set H H - (mean [Drawdown-from-mehr] of interior-patches / 1.5) set T-patch K-patch * H]
  ]
  ][read-real-data]

  prepare-equations
  solve-once
  update-unconfined-transmissivities
end

to update-unconfined-transmissivities
  ask interior-patches [set T-patch (K-patch * H)]
end



to calculate-H-unit-hydrograph
;if change-datum? = true
;[
;    change-datum-for-showing-the-results
;  ]

  let list-of-Pizo-patches sort-on  [Corresponding-Pizo] interior-patches with [Pizo? = true]
  let i 0
  set Total-ATimesH 0
  while [i <= (length list-of-Pizo-patches - 1) ]
  [
      ;ifelse change-datum? [ask item i list-of-Pizo-patches [set my-ATimesH area-monitored-patches-by-this-Pizo * H-Hydrograph ]][
    ask item i list-of-Pizo-patches [set my-ATimesH area-monitored-patches-by-this-Pizo * H ];]
    set Total-ATimesH Total-ATimesH + my-ATimesH
    set i i + 1
  ]
  set H-unit-hydrograph Total-ATimesH / (count interior-patches * delta ^ 2)

end



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; various markets ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; various markets ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; various markets ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; various markets ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; various markets ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; various markets ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; various markets ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



to setup-model
  ;set create-farmers-randomly? true
  set SA-crop-production 0
  set SA-transacted-price 0
  set SA-transacted-amount 0
  set SA-socres 0
  set SA-drawdown 0
  set SA-market-participant 0
  set SA-breaches 0
  set SA-water-permits 0
  if Run-Watermarket? = false [ set Run-WaterMarket? true]
  if Run-SocialModel? = false [set Run-SocialModel? true]
  setup-Groundwater
  setup-WaterMarket
  if Run-Watermarket? = true [ set Run-WaterMarket? false]
  if Run-SocialModel? = true [set Run-SocialModel? false]
  set Market-was-running? false
end


to Run-discriminatory-sensitivity-analysis
  if year = 2002 [set MaxAllowableWT 180 set SustainableWT 7]
if dynamic-policy?
 [
    let delta-H precision (mean [Drawdown-from-mehr] of interior-patches with [area-under-production > 0] / 1.4) 2
    if year >= 2003 [set MaxAllowableWT MaxAllowableWT + delta-H set SustainableWT SustainableWT + delta-H]
  ]
  set dynamic-fine-and-monitoring? false
  set Market-was-running? true
  set delta-t 365
  set Run-WaterMarket? true
  set auction-type "discriminatory-price-double-auction"
  set Run-SocialModel? true
  ifelse (Run-WaterMarket? = false)[go-GroundWater]
  [
    ask interior-patches [set Hinitial H]
    go-WaterMarket
    iterate
    calculate-H-unit-hydrograph
    ask interior-patches [set Drawdown-from-Mehr (Hinitial - H)]
    set SA-crop-production SA-crop-production + mean-Farmer-this-year-TOutput-tonph
    set SA-transacted-price SA-transacted-price + this-year-mean-sold-price
    set SA-transacted-amount SA-transacted-amount + this-year-bought-water-MCM
    set SA-socres SA-socres + score-mean
    let mean-drawdown mean [Drawdown-from-Mehr] of interior-patches
    set SA-drawdown SA-drawdown + mean-drawdown
    set SA-market-participant SA-market-participant + sellers-num + buyers-num
    set SA-breaches SA-breaches + total-breaches-MCM
    let total-water-permits sum [Farmer-WP] of Farmers
    set SA-water-permits SA-water-permits + total-water-permits
    tick

    set year year + 1
    set model-ready? true
    if auction-type = "discriminatory-price-double-auction" [Update-RentSeeking]
    if auction-type = "uniform-price-double-auction"  [Update-RentSeeking]
    if auction-type = "equilibrium-price-double-auction" [Update-RentSeeking]



  ]



end



to Run-yearly-no-market
   let x H-unit-Hydrograph

  set dynamic-fine-and-monitoring? false
  set Run-WaterMarket? false
  set Run-SocialModel? false
;  if Market-was-running? [setup-number-and-Qwells]                               ;; for running no market right after a market you should add this to update the Qwell-Farmer for calculate-Tprofit procedure
  set Market-was-running? false
   ask interior-patches with [area-under-production > 0]
  [
    set WP (Qwell-Farmer * 365 / 1000)
  ]
;   ask interior-patches with [well? = true][set Qwell 0 foreach list-of-wells-here [v -> set Qwell precision (Qwell + gis:property-value v "QINPUTM3DA") 2] set Ut 1]
  ask Farmers [let w 0 ask Farmer-patches[set w w + WP] set Farmer-WP w set Farmer-WP0 Farmer-WP]
  set delta-t 365



  ifelse (Run-WaterMarket? = false)[go-GroundWater]
  [
  ask interior-patches [set Hinitial H]
  go-WaterMarket
  iterate
  calculate-H-unit-hydrograph

  tick
    ask interior-patches [set Drawdown-from-Mehr (Hinitial - H)]
        if year = 2002 [setup-hydrolic-parameters]

  set year year + 1

    set model-ready? true

  ]
  print word "delta-H: " (x - H-unit-Hydrograph)
  end

to Run-uniform-market
  if year = 2002 [set MaxAllowableWT 180 set SustainableWT 7]
if dynamic-policy?
 [
    let delta-H precision (mean [Drawdown-from-mehr] of interior-patches with [area-under-production > 0] / 1.4 ) 2
    if year >= 2003 [set MaxAllowableWT MaxAllowableWT + delta-H set SustainableWT SustainableWT + delta-H]
  ]

  set dynamic-fine-and-monitoring? false
  set Run-WaterMarket? true
  set Market-was-running? true
  set delta-t 365
  set auction-type "uniform-price-double-auction"
  set Run-SocialModel? false
  ifelse (Run-WaterMarket? = false)[go-GroundWater]
  [
  ask interior-patches [set Hinitial H]
  go-WaterMarket
  iterate
  calculate-H-unit-hydrograph

  tick
    ask interior-patches [set Drawdown-from-Mehr (Hinitial - H)]
  set year year + 1
    set model-ready? true
     if auction-type = "discriminatory-price-double-auction" [Update-RentSeeking]
    if auction-type = "uniform-price-double-auction"  [Update-RentSeeking]
    if auction-type = "equilibrium-price-double-auction" [Update-RentSeeking]


  ]

end

to Run-discriminatory-market

  if year = 2002 [set MaxAllowableWT 180 set SustainableWT 7]
  let x H-unit-Hydrograph
if dynamic-policy?
 [
    let delta-H precision (mean [Drawdown-from-mehr] of interior-patches with [area-under-production > 0] / 1.4) 2
    if year >= 2003 [set MaxAllowableWT MaxAllowableWT + delta-H set SustainableWT SustainableWT + delta-H]
  ]

  set dynamic-fine-and-monitoring? false

  set Market-was-running? true
  set Run-WaterMarket? true
  set delta-t 365
  set auction-type "discriminatory-price-double-auction"
  set Run-SocialModel? false
  ifelse (Run-WaterMarket? = false)[go-GroundWater]
  [
  ask interior-patches [set Hinitial H]
  go-WaterMarket
  iterate
  calculate-H-unit-hydrograph

   tick
    ask interior-patches [set Drawdown-from-Mehr (Hinitial - H)]
    set model-ready? true
    set year year + 1
    if auction-type = "discriminatory-price-double-auction" [Update-RentSeeking]
    if auction-type = "uniform-price-double-auction"  [Update-RentSeeking]
    if auction-type = "equilibrium-price-double-auction" [Update-RentSeeking]


  ]
  print word "delta-H: " (x - H-unit-Hydrograph)

end

to Run-equilibrium-market

  if year = 2002 [set MaxAllowableWT 180 set SustainableWT 7]
  let x H-unit-Hydrograph

if dynamic-policy?
 [
    let delta-H precision (mean [Drawdown-from-mehr] of interior-patches with [area-under-production > 0] / 1.4) 2
    if year >= 2003 [set MaxAllowableWT MaxAllowableWT + delta-H set SustainableWT SustainableWT + delta-H]
  ]
  set dynamic-fine-and-monitoring? false
  set Run-WaterMarket? true
  set Market-was-running? true
  set delta-t 365
  set auction-type "equilibrium-price-double-auction"
  set Run-SocialModel? false
  ifelse (Run-WaterMarket? = false)[go-GroundWater]
  [
  ask interior-patches [set Hinitial H]
  go-WaterMarket
  iterate
  calculate-H-unit-hydrograph

  tick
    ask interior-patches [set Drawdown-from-Mehr (Hinitial - H)]
  set year year + 1
    set model-ready? true
        if auction-type = "discriminatory-price-double-auction" [Update-RentSeeking]
    if auction-type = "uniform-price-double-auction"  [Update-RentSeeking]
    if auction-type = "equilibrium-price-double-auction" [Update-RentSeeking]


  ]
  print word "delta-H: " (x - H-unit-Hydrograph)


end



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; norm emergence ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; norm emergence ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; norm emergence ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; norm emergence ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; norm emergence ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; norm emergence ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; norm emergence ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; norm emergence ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


to Run-social-agency
  if year = 2002 [set MaxAllowableWT 180 set SustainableWT 18]
  let x H-unit-Hydrograph
  set dynamic-policy? true
if dynamic-policy?
 [
    let delta-H precision (mean [Drawdown-from-mehr] of interior-patches with [area-under-production > 0] / 1.4) 2
    if year >= 2003 [set MaxAllowableWT MaxAllowableWT + delta-H set SustainableWT SustainableWT + delta-H]
  ]
  set WaterBuyback-Program? true
  set dynamic-fine-and-monitoring? true
  set Market-was-running? true
  set Run-WaterMarket? true
  set delta-t 365
  set auction-type "discriminatory-price-double-auction"
  set Run-SocialModel? true
  ifelse (Run-WaterMarket? = false)[go-GroundWater]
  [
  ask interior-patches [set Hinitial H]
  go-WaterMarket
  iterate
  calculate-H-unit-hydrograph

   tick
    ask interior-patches [set Drawdown-from-Mehr (Hinitial - H)]
    set model-ready? true
    set year year + 1
    if auction-type = "discriminatory-price-double-auction" [Update-RentSeeking]
    if auction-type = "uniform-price-double-auction"  [Update-RentSeeking]
    if auction-type = "equilibrium-price-double-auction" [Update-RentSeeking]
    update-EnveAgencys-RentSeeking

  ]
  print word "delta-H: " (x - H-unit-Hydrograph)

end





to Run-discriminatory-weak-norm

  if year = 2002 [set MaxAllowableWT 180 set SustainableWT 7]
if dynamic-policy?
 [
    let delta-H precision (mean [Drawdown-from-mehr] of interior-patches with [area-under-production > 0] / 1.4) 2
    if year >= 2003 [set MaxAllowableWT MaxAllowableWT + delta-H set SustainableWT SustainableWT + delta-H]
  ]

  set dynamic-fine-and-monitoring? false
  set Market-was-running? true
  set delta-t 365
  set Run-WaterMarket? true
  set auction-type "discriminatory-price-double-auction"
  set Run-SocialModel? true
  ;ifelse year = 2002 [set monitoring-percent 100 set fine-magnitude 1] [
    set monitoring-percent 0 set fine-magnitude 0
  ;]
  ifelse (Run-WaterMarket? = false)[go-GroundWater]
  [
  ask interior-patches [set Hinitial H]
  go-WaterMarket
  iterate
  calculate-H-unit-hydrograph

  tick
  ask interior-patches [set Drawdown-from-Mehr (Hinitial - H)]
  set year year + 1
    set model-ready? true
         if auction-type = "discriminatory-price-double-auction" [Update-RentSeeking]
    if auction-type = "uniform-price-double-auction"  [Update-RentSeeking]
    if auction-type = "equilibrium-price-double-auction" [Update-RentSeeking]

  ]

end

to Run-discriminatory-strong-norm
  if year = 2002 [set MaxAllowableWT 180 set SustainableWT 7]
if dynamic-policy?
 [
    let delta-H precision (mean [Drawdown-from-mehr] of interior-patches with [area-under-production > 0] / 1.4) 2
    if year >= 2003 [set MaxAllowableWT MaxAllowableWT + delta-H set SustainableWT SustainableWT + delta-H]
  ]

  set dynamic-fine-and-monitoring? false
  set Market-was-running? true
  set delta-t 365
  set Run-WaterMarket? true
  set auction-type "discriminatory-price-double-auction"
  set Run-SocialModel? true
;  ifelse year = 2002 [set monitoring-percent 0 set fine-magnitude 0] [
    set monitoring-percent 100 set fine-magnitude 1
 ; ]
  ifelse (Run-WaterMarket? = false)[go-GroundWater]
  [
  ask interior-patches [set Hinitial H]
  go-WaterMarket
  iterate
  calculate-H-unit-hydrograph

  tick
    ask interior-patches [set Drawdown-from-Mehr (Hinitial - H)]
  set year year + 1
    set model-ready? true
         if auction-type = "discriminatory-price-double-auction" [Update-RentSeeking]
    if auction-type = "uniform-price-double-auction"  [Update-RentSeeking]
    if auction-type = "equilibrium-price-double-auction" [Update-RentSeeking]

  ]

end

to Run-discriminatory-dynamic-norm
  if year = 2002 [set MaxAllowableWT 180 set SustainableWT 7]
if dynamic-policy?
 [
    let delta-H precision (mean [Drawdown-from-mehr] of interior-patches with [area-under-production > 0] / 1.4) 2
    if year >= 2003 [set MaxAllowableWT MaxAllowableWT + delta-H set SustainableWT SustainableWT + delta-H]
  ]
  set dynamic-fine-and-monitoring? true
  set Market-was-running? true
  set delta-t 365
  set Run-WaterMarket? true
  set auction-type "discriminatory-price-double-auction"
  set Run-SocialModel? true
  if year = 2002 [set monitoring-percent 90]
  ifelse (Run-WaterMarket? = false)[go-GroundWater]
  [
    ask interior-patches [set Hinitial H]
    go-WaterMarket
    iterate
    calculate-H-unit-hydrograph
    tick
    ask interior-patches [set Drawdown-from-Mehr (Hinitial - H)]
    set year year + 1
    set model-ready? true
    if auction-type = "discriminatory-price-double-auction" [Update-RentSeeking]
    if auction-type = "uniform-price-double-auction"  [Update-RentSeeking]
    if auction-type = "equilibrium-price-double-auction" [Update-RentSeeking]




  ]



end














to predict-yearly-no-market
  ifelse year < 2018 [Run-yearly-no-market][Run-yearly-no-market]
end

to predict-uniform-market
  ifelse year < 2018 [Run-yearly-no-market][Run-uniform-market]
end

to predict-equilibrium-market
  ifelse year < 2018 [Run-yearly-no-market][Run-equilibrium-market]
end



to predict-discriminatory-market
  ifelse year < 2018 [Run-yearly-no-market][Run-discriminatory-market]
end


to predict-discriminatory-weak-norm
  ifelse year < 2018 [Run-yearly-no-market]
  [
    Run-discriminatory-weak-norm

  ]
end


to predict-discriminatory-strong-norm
  ifelse year < 2018 [Run-yearly-no-market][Run-discriminatory-strong-norm]
end

to predict-discriminatory-dynamic-norm
  ifelse year < 2018 [Run-yearly-no-market][Run-discriminatory-dynamic-norm]
end


to Run-Economic-agency
  if year = 2002 [set MaxAllowableWT 180 set SustainableWT 15]
  let x H-unit-Hydrograph
  set dynamic-policy? true
if dynamic-policy?
 [
    let delta-H precision (mean [Drawdown-from-mehr] of interior-patches with [area-under-production > 0] / 1.4) 2
    if year >= 2003 [set MaxAllowableWT MaxAllowableWT + delta-H set SustainableWT SustainableWT + delta-H]
  ]
  set WaterBuyback-Program? true
  set dynamic-fine-and-monitoring? true
  set Market-was-running? true
  set Run-WaterMarket? true
  set delta-t 365
  set auction-type "discriminatory-price-double-auction"
  set Run-SocialModel? false
  ifelse (Run-WaterMarket? = false)[go-GroundWater]
  [
  ask interior-patches [set Hinitial H]
  go-WaterMarket
  iterate
  calculate-H-unit-hydrograph

   tick
    ask interior-patches [set Drawdown-from-Mehr (Hinitial - H)]
    set model-ready? true
    set year year + 1
    if auction-type = "discriminatory-price-double-auction" [Update-RentSeeking]
    if auction-type = "uniform-price-double-auction"  [Update-RentSeeking]
    if auction-type = "equilibrium-price-double-auction" [Update-RentSeeking]


  ]
  print word "delta-H: " (x - H-unit-Hydrograph)

end
@#$#@#$#@
GRAPHICS-WINDOW
-315
980
1541
2465
-1
-1
12.0
1
10
1
1
1
0
0
0
1
0
153
0
122
0
0
1
ticks
30.0

BUTTON
1200
10
1365
51
get ready to run
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
1455
45
1615
78
delta-t
delta-t
30
365
365.0
335
1
[days]
HORIZONTAL

CHOOSER
1035
1457
1232
1502
view
view
"wells" "Qwell m3/day" "agents' farms" "patch numbering" "area covered by pizo km2" "usage of the wells" "all the time transactions" "this year transactions" "Heads (contours)" "Water Table (contours)" "recharge" "K (contours)"
9

BUTTON
1035
1504
1214
1549
NIL
refresh-view
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

MONITOR
972
1457
1035
1502
NIL
year
17
1
11

MONITOR
912
1457
970
1502
NIL
month
17
1
11

SWITCH
1295
385
1435
418
Run-WaterMarket?
Run-WaterMarket?
0
1
-1000

SLIDER
1615
246
1805
279
transaction-cost-ratio
transaction-cost-ratio
0
20
0.5
0.5
1
precent
HORIZONTAL

SLIDER
1615
305
1805
338
energy-price
energy-price
1
10
2.0
1
1
Hezar Toman
HORIZONTAL

SLIDER
1615
275
1805
308
pistachio-price
pistachio-price
50
150
100.0
25
1
Hezar Toman
HORIZONTAL

PLOT
0
10
170
190
mean cap 
year
Ut
2002.0
2003.0
0.0
1.0
true
false
"" ""
PENS
"default" 1.0 1 -16777216 true "" "if model-ready? = true\n[\nplotxy year mean [Ut] of interior-patches with [well? = true and Qwell-Farmer > 0]\n]"

PLOT
385
10
630
190
mean Q well [m3/day]
month or year
Qt
0.0
1.0
950.0
1140.0
true
true
"" ""
PENS
"Buyers" 1.0 0 -13345367 true "" "if model-ready? = true[\nplot (Buyers-WU) * 1000 / 365 \n]"
"sellers" 1.0 0 -2674135 true "" "if model-ready? = true[\nplot (sellers-WU) * 1000 / 365 \n]"
"inactives" 1.0 0 -13840069 true "" "if model-ready? = true[\nplot (Inactives-WU) * 1000 / 365 \n] "
"All-Farmers" 1.0 0 -16382462 true "" "if model-ready? = true[\nplot (Farmers-WU) * 1000 / 365 \n]"

PLOT
585
190
900
365
volume of transaction [MCM]
year
MCM 
2002.0
2003.0
0.0
10.0
true
true
"" ""
PENS
"bought" 1.0 1 -14835848 true "" "if model-ready? = true  and Run-WaterMarket? \n[plotxy year this-year-bought-water-MCM]"
"sold" 1.0 0 -2674135 true "" "if model-ready? = true and Run-WaterMarket? \n[plotxy year this-year-sold-water-MCM]"

PLOT
625
10
940
190
mean water price [T/m3]
 year
toman
2002.0
2003.0
0.0
10.0
true
true
"" ""
PENS
"sold" 1.0 1 -2674135 true "" "if model-ready? = true and Run-WaterMarket? [\nplotxy year this-year-mean-sold-price * 1000\n]"
"bought" 1.0 0 -14835848 true "" "if model-ready? = true  and Run-WaterMarket? [\nplotxy year this-year-mean-bought-price * 1000\n]"

PLOT
1490
1900
2035
2210
RS active Buyers
year
R-S
2002.0
2003.0
0.0
1.1
true
false
"" ""
PENS
"active-Buyers" 1.0 1 -13345367 true "" " if model-ready? = true and Run-WaterMarket? and year > 2002\n[plotxy year mean-buyers-RentSeeking]"

SLIDER
1615
49
1867
82
num-farmers
num-farmers
0
400
200.0
50
1
group
HORIZONTAL

CHOOSER
1615
79
1805
124
auction-type
auction-type
"uniform-price-double-auction" "discriminatory-price-double-auction" "equilibrium-price-double-auction"
1

TEXTBOX
1625
20
1805
45
market parameters: 
19
0.0
1

TEXTBOX
1371
16
1616
41
groundwater parameters:
20
0.0
1

PLOT
0
365
250
550
 E-score [MT/ha]
year
NB / ha
2002.0
2003.0
100.0
150.0
true
true
"" ""
PENS
"Farmers" 1.0 0 -16777216 true "" "if model-ready? = true\n[plotxy year E-score-mean]"
"Buyers" 1.0 0 -13345367 true "" "if model-ready? = true\n[plotxy year E-score-Buyers]"
"Sellers_1" 1.0 0 -2674135 true "" "if model-ready? = true\n[plotxy year E-score-Sellers]"
"Inactives_1" 1.0 0 -13840069 true "" "if model-ready? = true\n[plotxy year E-score-Inactives]"

SLIDER
1615
335
1805
368
MaxAllowableWT
MaxAllowableWT
20
200
187.90000000000003
1
1
meters
HORIZONTAL

PLOT
-5
550
255
730
demand-supply-curve
Quantity
price
0.0
5000.0
0.0
50000.0
false
true
"" ""
PENS
"Supply Curve" 1.0 2 -10899396 true "" "if model-ready? = true and Run-WaterMarket?[\nforeach global-supply-price-points-this-year [i -> plotxy item 0 i (item 1 i * item 0 i) ]\n  ]"
"Demand Curve" 1.0 2 -2674135 true "" "if model-ready? = true and Run-WaterMarket? [\nforeach global-demand-price-points-this-year [i -> plotxy item 0 i (item 1 i * item 0 i) ]\n  ]"

PLOT
465
365
685
550
mean farmers revenue [MT/ha]
year
Re / ha
2002.0
2003.0
100.0
150.0
true
true
"" ""
PENS
"Farmers" 1.0 0 -16777216 true "" "if model-ready? = true\n[\nplotxy year mean-Farmer-this-year-Rph\n]"
"Buyers" 1.0 0 -13345367 true "" "if model-ready? = true\n[\nplotxy year mean-Buyers-this-year-Rph\n]"
"Sellers_1" 1.0 0 -2674135 true "" "if model-ready? = true\n[\nplotxy year mean-Sellers-this-year-Rph\n]"
"Inactives_1" 1.0 0 -13840069 true "" "if model-ready? = true\n[\nplotxy year mean-Inactives-this-year-Rph\n]"

PLOT
685
365
910
550
mean farmers PC [MT/ha]
year
PC / ha 
2002.0
2003.0
0.0
10.0
true
true
"" ""
PENS
"Farmers" 1.0 0 -16777216 true "" "if model-ready? = true\n[plotxy year mean-Farmer-this-year-pumping-costph]"
"Buyers" 1.0 0 -13345367 true "" "if model-ready? = true\n[plotxy year mean-Buyers-this-year-pumping-costph]"
"Sellers_1" 1.0 0 -2674135 true "" "if model-ready? = true\n[plotxy year mean-Sellers-this-year-pumping-costph]"
"Inactives_1" 1.0 0 -13840069 true "" "if model-ready? = true\n[plotxy year mean-Inactives-this-year-pumping-costph]"

PLOT
900
185
1130
365
H hydrograph
month or year
H
0.0
1.0
1381.0
1400.0
true
false
"" ""
PENS
"default" 1.0 1 -16777216 true "" "if  H-unit-Hydrograph  > 0 and model-ready? = true [plot H-unit-Hydrograph ]\n"

PLOT
0
190
265
365
mean farms water table
month or year
WT
0.0
1.0
0.0
60.0
true
false
"" ""
PENS
"default" 1.0 1 -16777216 true "" "if model-ready? = true [\nplot water-table-mean]"

SWITCH
1295
415
1435
448
Run-SocialModel?
Run-SocialModel?
0
1
-1000

PLOT
0
730
400
905
Lorenz curve — Wealth
pop%
wealth%
0.0
100.0
0.0
100.0
false
true
"" ""
PENS
"wealth" 1.0 0 -2674135 true "" "if model-ready? = true\n[plot-pen-reset\nset-plot-pen-interval 100 / num-farmers\nplot 0\nforeach lorenz-points plot]\n"
"equall" 100.0 0 -16644859 true "plot 0\nplot 100" ""

PLOT
400
730
600
905
Gini Index v. Time
year
Gini
0.0
1.0
0.0
1.0
true
false
"" ""
PENS
"wealth" 1.0 0 -2674135 true "" "if model-ready? = true\n[plot gini-index]"

PLOT
820
905
1020
1085
histogram — boldness
B
Num
0.0
1.0
0.0
50.0
true
false
"" "set-histogram-num-bars 20\nset-plot-x-range 0 1.1"
PENS
"default" 0.05 1 -16777216 false "" "histogram [boldness] of Farmers"

PLOT
1019
905
1219
1085
histogram — vengefulness
V
Num
0.0
1.0
0.0
50.0
true
false
"" "set-histogram-num-bars 20\nset-plot-x-range 0 1.1"
PENS
"default" 0.05 1 -16777216 true "" "histogram [ave-vengefulness] of Farmers"

PLOT
0
905
400
1085
boldness and vengefulness
year
NIL
0.0
1.0
0.0
1.0
true
true
"" ""
PENS
"boldness" 1.0 0 -2674135 true "" "if model-ready? = true and Run-SocialModel? \n[plot  mean-boldness]"
"vengefulness" 1.0 0 -13345367 true "" "if model-ready? = true and Run-SocialModel? \n[plot  mean-vengefulness]"

TEXTBOX
1515
430
1690
455
Social parameters:
19
0.0
1

SLIDER
1510
520
1685
553
monitoring-percent
monitoring-percent
0
100
100.0
5
1
percent
HORIZONTAL

SLIDER
1509
490
1684
523
fine-magnitude
fine-magnitude
0
1
0.15
0.1
1
NIL
HORIZONTAL

SLIDER
1509
460
1684
493
memory-length
memory-length
1
5
3.0
1
1
years
HORIZONTAL

PLOT
380
905
595
1085
norm strength
 year
N-S
2002.0
2003.0
-1.0
1.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "if model-ready? = true and Run-SocialModel? \n[plotxy year norm-strength]"

PLOT
595
905
820
1085
compliance rate %
year 
Compliance
2002.0
2003.0
0.0
1.0
true
false
"" ""
PENS
"default" 1.0 1 -16777216 true "" "if model-ready? = true and Run-WaterMarket? [plotxy year compliance-level]"

PLOT
600
730
840
905
total volume of breaches [MCM / Year]
year 
MCM 
2002.0
2003.0
0.0
10.0
true
true
"" ""
PENS
"Farmers" 1.0 1 -16777216 true "" "if model-ready? = true and Run-SocialModel? \n[plotxy year total-breaches-MCM ]"
"Sellers_1" 1.0 0 -2674135 true "" "if model-ready? = true and Run-SocialModel? \n[plotxy year Sellers-breaches-MCM ]"
"Buyers" 1.0 0 -13345367 true "" "if model-ready? = true and Run-SocialModel? \n[plotxy year Buyers-breaches-MCM ]"
"Inactves" 1.0 0 -10899396 true "" "if model-ready? = true and Run-SocialModel? \n[plotxy year Inactives-breaches-MCM ]"

PLOT
250
365
465
550
score [MT / ha]
year 
NB
2002.0
2003.0
100.0
150.0
true
true
"" ""
PENS
"Farmers" 1.0 0 -16777216 true "" "if model-ready? = true\n[plotxy year score-mean  ]"
"Buyers" 1.0 0 -13345367 true "" "if model-ready? = true\n[plotxy year score-Buyers]"
"Sellers_1" 1.0 0 -2674135 true "" "if model-ready? = true\n[plotxy year score-Sellers]"
"Inactives_1" 1.0 0 -13840069 true "" "if model-ready? = true\n[plotxy year score-Inactives]"

MONITOR
340
815
400
860
Gini Index
precision ((gini-index-reserve / num-farmers) / 0.5) 3
17
1
11

PLOT
460
550
765
730
mean output [Ton/ha]
year
output
2002.0
2003.0
0.5
1.15
true
true
"" ""
PENS
"Farmers" 1.0 0 -16645628 true "" "if model-ready? = true\n[plotxy year mean-Farmer-this-year-TOutput-tonph ]"
"Buyers" 1.0 0 -13345367 true "" "if model-ready? = true\n[plotxy year mean-Buyers-this-year-TOutput-tonph ]"
"Sellers_1" 1.0 0 -2674135 true "" "if model-ready? = true\n[plotxy year mean-Sellers-this-year-TOutput-tonph ]"
"Inactives_1" 1.0 0 -13840069 true "" "if model-ready? = true\n[plotxy year mean-Inactives-this-year-TOutput-tonph ]"

PLOT
1015
730
1235
905
PCP mm
year
NIL
0.0
3.0
0.0
3.0
true
true
"" ""
PENS
"Rafsanjan" 1.0 0 -10899396 true "" "if model-ready? = true[plot mean-precipitation-Rafsanjan]"
"Anar" 1.0 0 -5298144 true "" "if model-ready? = true[plot mean-precipitation-Anar]"
"mean" 1.0 0 -13628663 true "" "if model-ready? = true[plot mean [Precipitation] of interior-patches]"

PLOT
1015
550
1235
730
Recharge mm
 year
NIL
0.0
3.0
0.0
3.0
true
true
"" ""
PENS
"Rafsanjan" 1.0 0 -13840069 true "" "if model-ready? = true\n[ \nplot mean-Recharge-Rafsanjan\n]"
"Anar" 1.0 0 -2674135 true "" "if model-ready? = true\n[ \nplot mean-Recharge-Anar\n]"

BUTTON
1130
370
1295
403
NIL
Run-uniform-market
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
1130
400
1295
433
Run-discriminatory-market
\nRun-discriminatory-market\n
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
1129
337
1294
371
Run-yearly-no-market
\nRun-yearly-no-market\n
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
1130
495
1295
529
NIL
Run-discriminatory-weak-norm
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
1130
460
1295
494
NIL
Run-discriminatory-strong-norm
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SWITCH
1615
395
1812
428
create-farmers-randomly?
create-farmers-randomly?
0
1
-1000

PLOT
910
365
1130
550
Environmental Agency
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"TC BT" 1.0 0 -16777216 true "" "if model-ready? = true and Run-WaterMarket? \n[plot sum-Farmer-this-year-transaction-cost]"
"BC BT/100" 1.0 0 -14439633 true "" "if model-ready? = true and Run-WaterMarket? and WaterBuyback-Program? \n[\nplot [BC] of EnvAgency 200 / 100000\n]"
"Volum MCM" 1.0 0 -13345367 true "" "if model-ready? = true and Run-WaterMarket? and WaterBuyback-Program? \n[\nplot [Turtle-bought-water] of EnvAgency 200 / 1000\n]"
"TP MT" 1.0 0 -2674135 true "" "if model-ready? = true and Run-WaterMarket? and WaterBuyback-Program? \n[\nplot [Turtle-target-price] of EnvAgency 200\n]"

SLIDER
1615
365
1805
398
SustainableWT
SustainableWT
0
50
25.90000000000001
1
1
meters
HORIZONTAL

MONITOR
315
995
372
1040
MB
precision mean-boldness 2
17
1
11

MONITOR
315
1035
372
1080
MV
precision mean-vengefulness 2
17
1
11

MONITOR
315
955
372
1000
NS
precision norm-strength 2
17
1
11

BUTTON
1130
525
1295
558
NIL
Run-discriminatory-dynamic-norm\n
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SWITCH
1510
550
1700
583
dynamic-fine-and-monitoring?
dynamic-fine-and-monitoring?
0
1
-1000

PLOT
1215
905
1400
1085
fine-magnitude
year 
FM
2002.0
2003.0
0.0
1.0
true
false
"" ""
PENS
"default" 1.0 1 -16777216 true "" "if Run-SocialModel? and model-ready? = true\n[\nplotxy year fine-magnitude\n]"

PLOT
840
730
1020
910
monitoring-percent 
year
MP
2002.0
2003.0
0.0
100.0
true
false
"" ""
PENS
"default" 1.0 1 -16777216 true "" "if Run-SocialModel? and model-ready? = true\n[plotxy year monitoring-percent]"

MONITOR
1295
300
1370
345
NIL
Farmers-WU
17
1
11

MONITOR
890
120
947
165
NIL
RWU
17
1
11

PLOT
940
10
1200
185
Defecit-Irrigation? mm/m2.yr
year
NIL
2002.0
2003.0
700.0
1000.0
true
true
"" ""
PENS
"RWU" 1.0 0 -1184463 true "" "if model-ready? = true [plotxy year RWU]"
"Farmers-WU" 1.0 0 -13493215 true "" "if model-ready? = true [plotxy year Farmers-WUmm]"
"Buyers WU" 1.0 0 -13345367 true "" "if model-ready? = true [plotxy year Buyers-WUmm]"
"Sellers WU" 1.0 0 -2674135 true "" "if model-ready? = true [plotxy year Sellers-WUmm]"
"Inactives-WU" 1.0 0 -13840069 true "" "if model-ready? = true [plotxy year Inactives-WUmm]"

PLOT
265
190
585
370
mean WP [m3/day]
year 
WP
0.0
1.0
800.0
1180.0
true
true
"" ""
PENS
"Buyers" 1.0 0 -13345367 true "" "if model-ready? = true[\nplot (Buyers-WP) * 1000 / 365 \n]"
"Sellers_1" 1.0 0 -2674135 true "" "if model-ready? = true[\nplot (Sellers-WP) * 1000 / 365 \n]"
"Inactives_1" 1.0 0 -13840069 true "" "if model-ready? = true[\nplot (Inactives-WP) * 1000 / 365 \n]"
"Farmers" 1.0 0 -16644859 true "" "if model-ready? = true[\nplot (Farmers-WP) * 1000 / 365\n]"

MONITOR
845
330
902
375
Ut=1
Farmers-with-Ut1
17
1
11

MONITOR
845
240
902
285
Ut=0
Farmers-with-Ut0
17
1
11

MONITOR
1325
160
1390
205
NIL
Buyers-WU
17
1
11

MONITOR
1305
255
1370
300
NIL
Sellers-WU
17
1
11

MONITOR
515
280
575
325
NIL
Buyers-num
17
1
11

MONITOR
565
145
625
190
NIL
Sellers-num
17
1
11

MONITOR
1130
190
1195
235
Buyers-WP
precision Buyers-WP 2
17
1
11

MONITOR
1130
255
1202
300
Sellers-WP
precision Sellers-WP 2
17
1
11

MONITOR
1130
300
1200
345
NIL
Farmers-WP
17
1
11

MONITOR
1220
190
1285
235
NIL
Buyers-WB
17
1
11

MONITOR
1220
255
1285
300
NIL
Sellers-WS
17
1
11

TEXTBOX
1200
210
1215
228
+
15
0.0
1

TEXTBOX
1205
270
1220
288
-
16
0.0
1

TEXTBOX
1290
215
1310
233
=?
12
0.0
1

TEXTBOX
1290
275
1310
301
=?
12
0.0
1

SWITCH
1680
455
1805
488
deficit-irrigation?
deficit-irrigation?
0
1
-1000

BUTTON
1130
430
1295
463
NIL
Run-equilibrium-market
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

MONITOR
845
285
902
330
Ut > 1
Farmers-with-Ut>1
17
1
11

INPUTBOX
1535
105
1615
180
delta
970.587
1
0
Number

INPUTBOX
2073
832
2213
892
additional-inflow-south-H
3.76425
1
0
Number

INPUTBOX
1235
650
1285
710
K3
0.926711
1
0
Number

INPUTBOX
1285
650
1335
710
K4
1.53768
1
0
Number

INPUTBOX
1335
650
1385
710
K7
3.55236
1
0
Number

INPUTBOX
1385
650
1435
710
K8
0.951553
1
0
Number

INPUTBOX
1435
650
1485
710
K9
3.55615
1
0
Number

INPUTBOX
1485
650
1535
710
K10
0.743481
1
0
Number

INPUTBOX
1535
650
1585
710
K11
0.885145
1
0
Number

INPUTBOX
1585
650
1635
710
K13
2.21714
1
0
Number

INPUTBOX
1635
650
1685
710
K14
1.1938
1
0
Number

INPUTBOX
1685
650
1735
710
K15
3.4699
1
0
Number

INPUTBOX
1730
650
1780
710
K19
1.37453
1
0
Number

INPUTBOX
1235
710
1285
770
K20
1.22084
1
0
Number

INPUTBOX
1285
710
1335
770
K24
0.740185
1
0
Number

INPUTBOX
1335
710
1385
770
K26
0.595712
1
0
Number

INPUTBOX
1385
710
1435
770
K31
3.16149
1
0
Number

INPUTBOX
1435
710
1485
770
K33
3.55224
1
0
Number

INPUTBOX
1485
710
1535
770
K34
1.32827
1
0
Number

INPUTBOX
1535
710
1585
770
K38
3.44988
1
0
Number

INPUTBOX
1585
710
1635
770
K39
1.37099
1
0
Number

INPUTBOX
1635
710
1685
770
K43
3.90564
1
0
Number

INPUTBOX
1685
710
1735
770
K44
2.30051
1
0
Number

INPUTBOX
1735
710
1785
770
K49
0.922194
1
0
Number

INPUTBOX
1235
770
1285
830
K50
0.775463
1
0
Number

INPUTBOX
1285
770
1335
830
K51
3.7434
1
0
Number

INPUTBOX
1335
770
1385
830
K53
3.54284
1
0
Number

INPUTBOX
1385
770
1435
830
K56
2.17191
1
0
Number

INPUTBOX
1435
770
1485
830
K58
2.04587
1
0
Number

INPUTBOX
1485
770
1535
830
K59
2.49229
1
0
Number

INPUTBOX
1535
770
1585
830
K60
1.18257
1
0
Number

INPUTBOX
1585
770
1635
830
K63
1.55587
1
0
Number

INPUTBOX
1635
770
1685
830
K65
2.80656
1
0
Number

INPUTBOX
1685
770
1735
830
K66
1.62997
1
0
Number

INPUTBOX
1735
770
1785
830
K69
2.84733
1
0
Number

INPUTBOX
1235
830
1285
890
K70
2.69456
1
0
Number

INPUTBOX
1285
830
1335
890
K72
1.29354
1
0
Number

INPUTBOX
1335
830
1385
890
K74
1.72396
1
0
Number

INPUTBOX
1385
830
1435
890
K76
1.53384
1
0
Number

INPUTBOX
1435
830
1485
890
K77
1.27572
1
0
Number

INPUTBOX
1485
830
1535
890
K79
0.745495
1
0
Number

INPUTBOX
1535
830
1585
890
K80
1.38314
1
0
Number

INPUTBOX
1585
830
1635
890
K81
0.641062
1
0
Number

INPUTBOX
1635
830
1685
890
K82
3.42156
1
0
Number

INPUTBOX
1925
355
2092
415
subtract-outflow-west-right-above-H
55.0
1
0
Number

INPUTBOX
2180
750
2343
810
subtract-outflow-east-right-below-H
69.7212
1
0
Number

TEXTBOX
1175
235
1440
253
ML per year
11
0.0
1

INPUTBOX
2213
832
2293
892
K-inflow-south
4.45274
1
0
Number

INPUTBOX
1930
555
2100
615
K-outflow-west-left-above-right
1.25383
1
0
Number

INPUTBOX
2086
430
2246
490
K-outflow-east-left-middle
5.05058
1
0
Number

INPUTBOX
1925
295
2092
355
K-outflow-west-right-above
3.21245
1
0
Number

INPUTBOX
2180
690
2344
750
K-outflow-east-right-below
4.16233
1
0
Number

INPUTBOX
1930
615
2100
675
subtract-outflow-west-left-above-H-right
-15.0
1
0
Number

INPUTBOX
2086
490
2246
550
subtract-outflow-east-left-middle-H
95.0
1
0
Number

INPUTBOX
2080
150
2240
210
K-inflow-east-middle
1.24834
1
0
Number

INPUTBOX
2075
10
2235
70
K-inflow-west-middle
5.00838
1
0
Number

INPUTBOX
2080
210
2240
270
additional-inflow-east-middle-H
-100.0
1
0
Number

INPUTBOX
2235
10
2390
70
K-inflow-west-below
5.97043
1
0
Number

INPUTBOX
1920
10
2075
70
K-inflow-west-above
3.13545
1
0
Number

INPUTBOX
2075
70
2235
130
additional-inflow-west-middle-H
-152.0
1
0
Number

INPUTBOX
2235
70
2390
130
additional-inflow-west-below-H
-79.0
1
0
Number

INPUTBOX
1920
70
2075
130
additional-inflow-west-above-H
-275.0
1
0
Number

INPUTBOX
2240
210
2395
270
additional-inflow-east-below-H
-85.2758
1
0
Number

INPUTBOX
2240
151
2395
211
K-inflow-east-below
2.82957
1
0
Number

INPUTBOX
1926
209
2081
269
additional-inflow-east-above-H
-45.1859
1
0
Number

INPUTBOX
1926
150
2081
210
K-inflow-east-above
5.59982
1
0
Number

INPUTBOX
2092
355
2259
415
subtract-outflow-west-right-middle-H
2.5
1
0
Number

INPUTBOX
2092
295
2259
355
K-outflow-west-right-middle
5.03008
1
0
Number

INPUTBOX
2259
356
2424
416
subtract-outflow-west-right-below-H
-15.0
1
0
Number

INPUTBOX
2259
296
2425
356
K-outflow-west-right-below
5.92776
1
0
Number

INPUTBOX
2275
615
2445
675
subtract-outflow-west-left-below-H
50.0
1
0
Number

INPUTBOX
2274
555
2444
615
K-outflow-west-left-below
5.406
1
0
Number

INPUTBOX
2246
490
2403
550
subtract-outflow-east-left-below-H
11.0
1
0
Number

INPUTBOX
2246
430
2404
490
K-outflow-east-left-below
4.94658
1
0
Number

INPUTBOX
1930
490
2087
550
subtract-outflow-east-left-above-H
20.6516
1
0
Number

INPUTBOX
1930
430
2087
490
K-outflow-east-left-above
4.75239
1
0
Number

INPUTBOX
2017
749
2181
809
subtract-outflow-east-right-above-H
1.0
1
0
Number

INPUTBOX
2017
689
2182
749
K-outflow-east-right-above
2.47398
1
0
Number

INPUTBOX
2100
615
2275
675
subtract-outflow-west-left-middle-H
168.0
1
0
Number

INPUTBOX
2100
555
2275
615
K-outflow-west-left-middle
1.47805
1
0
Number

INPUTBOX
1780
555
1932
615
K-outflow-west-left-above-left
0.417121
1
0
Number

INPUTBOX
1780
615
1932
675
subtract-outflow-west-left-above-H-left
6.0
1
0
Number

MONITOR
565
100
625
145
NIL
inactives-num
17
1
11

PLOT
170
10
385
190
number of participants
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"sellers" 1.0 0 -2674135 true "" "if model-ready? = true[plot Sellers-num]"
"Buyers" 1.0 0 -13345367 true "" "if model-ready? = true[plot Buyers-num]"
"inactives" 1.0 0 -13840069 true "" "if model-ready? = true[plot Inactives-num]"

INPUTBOX
1635
930
1685
990
Sy3
0.3
1
0
Number

INPUTBOX
1685
930
1735
990
Sy4
0.18
1
0
Number

INPUTBOX
1735
930
1785
990
Sy7
0.21
1
0
Number

INPUTBOX
1785
930
1835
990
Sy8
0.1
1
0
Number

INPUTBOX
1835
930
1885
990
Sy9
0.26
1
0
Number

INPUTBOX
1885
930
1935
990
Sy10
0.24
1
0
Number

INPUTBOX
1935
930
1985
990
Sy11
0.13
1
0
Number

INPUTBOX
1985
930
2035
990
Sy13
0.23
1
0
Number

INPUTBOX
2035
930
2085
990
Sy14
0.25
1
0
Number

INPUTBOX
2085
930
2135
990
Sy15
0.22
1
0
Number

INPUTBOX
2135
930
2185
990
Sy19
0.3
1
0
Number

INPUTBOX
1635
990
1685
1050
Sy20
0.26
1
0
Number

INPUTBOX
1685
990
1735
1050
Sy24
0.25
1
0
Number

INPUTBOX
1735
990
1785
1050
Sy26
0.21
1
0
Number

INPUTBOX
1785
990
1835
1050
Sy31
0.42
1
0
Number

INPUTBOX
1835
990
1885
1050
Sy33
0.08
1
0
Number

INPUTBOX
1885
990
1935
1050
Sy34
0.26
1
0
Number

INPUTBOX
1935
990
1985
1050
Sy38
0.45
1
0
Number

INPUTBOX
1985
990
2035
1050
Sy39
0.32
1
0
Number

INPUTBOX
2035
990
2085
1050
Sy43
0.11
1
0
Number

INPUTBOX
2085
990
2135
1050
Sy44
0.23
1
0
Number

INPUTBOX
2135
990
2185
1050
Sy49
0.45
1
0
Number

INPUTBOX
1635
1050
1685
1110
Sy50
0.31
1
0
Number

INPUTBOX
1685
1050
1735
1110
Sy51
0.21
1
0
Number

INPUTBOX
1735
1050
1785
1110
Sy53
0.22
1
0
Number

INPUTBOX
1785
1050
1835
1110
Sy56
0.2
1
0
Number

INPUTBOX
1835
1050
1885
1110
Sy58
0.26
1
0
Number

INPUTBOX
1885
1050
1935
1110
Sy59
0.18
1
0
Number

INPUTBOX
1935
1050
1985
1110
Sy60
0.2
1
0
Number

INPUTBOX
1985
1050
2035
1110
Sy63
0.22
1
0
Number

INPUTBOX
2035
1050
2085
1110
Sy65
0.12
1
0
Number

INPUTBOX
2085
1050
2135
1110
Sy66
0.22
1
0
Number

INPUTBOX
2135
1050
2185
1110
Sy69
0.12
1
0
Number

INPUTBOX
1635
1110
1685
1170
Sy70
0.17
1
0
Number

INPUTBOX
1685
1110
1735
1170
Sy72
0.18
1
0
Number

INPUTBOX
1735
1110
1785
1170
Sy74
0.15
1
0
Number

INPUTBOX
1785
1110
1835
1170
Sy76
0.23
1
0
Number

INPUTBOX
1835
1110
1885
1170
Sy77
0.14
1
0
Number

INPUTBOX
1885
1110
1935
1170
Sy79
0.13
1
0
Number

INPUTBOX
1935
1110
1985
1170
Sy80
0.22
1
0
Number

INPUTBOX
1985
1110
2035
1170
Sy81
0.26
1
0
Number

INPUTBOX
2035
1110
2085
1170
Sy82
0.16
1
0
Number

SWITCH
2080
1110
2185
1143
Changing-Boundary?
Changing-Boundary?
0
1
-1000

PLOT
250
550
460
730
Farms Drawdown
year 
Drawdown
2002.0
2015.0
0.0
1.0
true
false
"" ""
PENS
"Drawdown" 1.0 0 -2674135 true "" "if model-ready? = true \n[\nplotxy year mean [Drawdown-from-mehr] of interior-patches with [area-under-production > 0]\n]"

SWITCH
1680
425
1805
458
dynamic-policy?
dynamic-policy?
0
1
-1000

SWITCH
1295
355
1435
388
WaterBuyback-Program?
WaterBuyback-Program?
0
1
-1000

SLIDER
1435
355
1620
388
Agency's-Budget
Agency's-Budget
100
200
200.0
50
1
Milliard Toman
HORIZONTAL

SLIDER
1455
75
1615
108
Sy
Sy
0
1
0.2
0.1
1
NIL
HORIZONTAL

SWITCH
1680
485
1805
518
Genetic-Evolution?
Genetic-Evolution?
1
1
-1000

SLIDER
1680
515
1805
548
mutation-probability
mutation-probability
0
1
0.05
0.05
1
NIL
HORIZONTAL

PLOT
875
1120
1350
1390
Individual 1
NIL
NIL
0.0
1.0
0.0
1.0
true
true
"" ""
PENS
"sold MCM" 1.0 1 -2674135 true "" "plot [Farmer-sold-water] of [owner] of patch 55 102 / 1000"
"RS" 1.0 0 -16710651 true "" "plot [Farmer-RentSeeking] of [owner] of patch 55 102"
"Bought MCM_1" 1.0 1 -13345367 true "" "plot [Turtle-bought-water] of [owner] of patch 55 102 / 1000"
"Score MT E-2_1" 1.0 0 -13840069 true "" "plot [Score] of [owner] of patch 55 102 / 100"
"strategy" 1.0 0 -955883 true "" "plot [strategy] of [owner] of patch 55 102"

PLOT
1350
1170
1770
1440
Individual2
NIL
NIL
0.0
1.0
0.0
1.0
true
true
"" ""
PENS
"Bought MCM_1" 1.0 1 -13345367 true "" "plot [Turtle-bought-water] of [owner] of patch 76 75 / 1000"
"RS" 1.0 0 -15456499 true "" "plot [Farmer-RentSeeking] of [owner] of patch 76 75 "
"sold MCM" 1.0 1 -5298144 true "" "plot [Farmer-sold-water] of [owner] of patch 76 75 / 1000"
"Score MT E-2_1" 1.0 0 -13840069 true "" "plot [Score] of [owner] of patch 76 75 / 100"
"strategy" 1.0 0 -955883 true "" "plot [strategy] of [owner] of patch 76 75 / 100"

PLOT
2130
1170
2560
1440
Individual3
NIL
NIL
0.0
1.0
0.0
1.0
true
true
"" ""
PENS
"sold MCM" 1.0 1 -2674135 true "" "plot [Farmer-sold-water] of [owner] of patch 84 33 / 1000"
"Bought MCM_1" 1.0 1 -13345367 true "" "plot [Turtle-bought-water] of [owner] of patch 84 33 / 1000"
"RS" 1.0 0 -16113878 true "" "plot [Farmer-RentSeeking] of [owner] of patch 84 33"
"Score MT E-2_1" 1.0 0 -13840069 true "" "plot [Score] of [owner] of patch 84 33 / 100"
"strategy" 1.0 0 -955883 true "" "plot [strategy] of [owner] of patch 84 33 "

PLOT
1350
1390
1770
1655
Individual 4 
NIL
NIL
0.0
10.0
0.0
1.0
true
true
"" ""
PENS
"sold MCM " 1.0 1 -2674135 true "" "plot [Farmer-sold-water] of [owner] of patch 33 75 / 1000"
"RS" 1.0 0 -16644859 true "" "plot [Farmer-RentSeeking] of [owner] of patch 33 75"
"bought MCM" 1.0 1 -13345367 true "" "plot [Turtle-bought-water] of [owner] of patch 33 75 / 1000"
"score MT-2" 1.0 0 -10899396 true "" "plot [Score] of [owner] of patch 33 75 / 100"
"strategy" 1.0 0 -955883 true "" "plot [strategy] of [owner] of patch 33 75 / 100"

PLOT
1770
1390
2200
1655
Individual 5
NIL
NIL
0.0
1.0
0.0
1.0
true
true
"" ""
PENS
"sold MCM " 1.0 1 -2674135 true "" "plot [Farmer-sold-water] of [owner] of patch 95 41 / 1000"
"RS" 1.0 0 -16710398 true "" "plot [Farmer-RentSeeking] of [owner] of patch 95 41"
"bought MCM " 1.0 1 -13345367 true "" "plot [Turtle-bought-water] of [owner] of patch 95 41 / 1000"
"score MT E-2" 1.0 0 -14835848 true "" "plot [Score] of [owner] of patch 95 41 / 100"
"strategy" 1.0 0 -955883 true "" "plot [strategy] of [owner] of patch 95 41 "

MONITOR
1270
1220
1327
1265
LR
[Farmer-LearningRate] of [owner] of patch 55 102
17
1
11

MONITOR
1680
1275
1737
1320
LR
[Farmer-LearningRate] of [owner] of patch 76 75
17
1
11

MONITOR
2490
1255
2547
1300
LR
[Farmer-LearningRate] of [owner] of patch 84 33
17
1
11

MONITOR
1700
1490
1757
1535
LR
[Farmer-LearningRate] of [owner] of patch 33 75
17
1
11

MONITOR
2120
1495
2170
1540
LR
[Farmer-LearningRate] of [owner] of patch 95 41
17
1
11

PLOT
1770
1655
2200
1885
Individual 6 
NIL
NIL
0.0
1.0
0.0
1.0
true
true
"" ""
PENS
"Sold MCM _1" 1.0 1 -2674135 true "" "plot [Farmer-sold-water] of [owner] of patch 65 87 / 1000"
"RS" 1.0 0 -16645118 true "" "plot [Farmer-RentSeeking] of [owner] of patch 65 87"
"Bought MCM _1" 1.0 1 -13345367 true "" "plot [Turtle-bought-water] of [owner] of patch 65 87 / 1000"
"Score MT E-2_1" 1.0 0 -13840069 true "" "plot [Score] of [owner] of patch 65 87 / 100"
"Strategy_1" 1.0 0 -955883 true "" "plot [strategy] of [owner] of patch 65 87"

MONITOR
2115
1760
2165
1805
LR
[Farmer-LearningRate] of [owner] of patch 123 20
17
1
11

SWITCH
1495
180
1612
213
Equal-Cap?
Equal-Cap?
1
1
-1000

PLOT
1200
50
1415
200
WP-ID
NIL
NIL
2002.0
2003.0
500.0
800.0
true
true
"" ""
PENS
"WP" 1.0 0 -13345367 true "" "if model-ready? = true and Run-WaterMarket? [plotxy year Farmers-WP-total ]"
"ID" 1.0 0 -2674135 true "" "if model-ready? = true and Run-WaterMarket? [\nplotxy year Farmers-ID-total]"

PLOT
1200
200
1415
345
Social welfare
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"CS" 1.0 0 -13345367 true "" "plot sum [Consumer-Surplus] of Farmers "
"PS" 1.0 0 -2674135 true "" "plot sum [Producer-Surplus] of Farmers "
"SW" 1.0 0 -13840069 true "" "plot Social-Welfare"

PLOT
2035
1900
2525
2210
RS active sellers
NIL
NIL
2002.0
2003.0
0.0
1.0
true
false
"" ""
PENS
"Active-sellers" 1.0 1 -13345367 true "" "if model-ready? = true and year > 2002\n[plotxy year mean-sellers-RentSeeking ]"

PLOT
1490
2210
2035
2470
RS Inactive-Buyers
NIL
NIL
2002.0
2003.0
0.0
1.0
true
false
"" ""
PENS
"default" 1.0 1 -2674135 true "" "if model-ready? = true and year > 2002\n[plotxy year mean [Farmer-RentSeeking] of Farmers with [Turtle-Demand? = true and Turtle-Transaction? = false ]]"

PLOT
2035
2210
2525
2470
RS Inactive-sellers
NIL
NIL
2002.0
2003.0
0.0
1.0
true
false
"" ""
PENS
"default" 1.0 1 -2674135 true "" "if model-ready? = true and year > 2002\n[plotxy year mean [Farmer-RentSeeking] of Farmers with [Turtle-Supply? = true and Turtle-Transaction? = false ]]"

SLIDER
1615
120
1805
153
mean-EnvAgency-RentSeeking
mean-EnvAgency-RentSeeking
0
1
0.5
0.05
1
NIL
HORIZONTAL

SLIDER
1615
150
1805
183
mean-EnvAgency-LearningRate
mean-EnvAgency-LearningRate
0
1
0.8
0.5
1
NIL
HORIZONTAL

@#$#@#$#@
## WHAT IS IT?

(a general understanding of what the model is trying to show or explain)

## HOW IT WORKS

(what rules the agents use to create the overall behavior of the model)

## HOW TO USE IT

(how to use the model, including a description of each of the items in the Interface tab)

## THINGS TO NOTICE

(suggested things for the user to notice while running the model)

## THINGS TO TRY

(suggested things for the user to try to do (move sliders, switches, etc.) with the model)

## EXTENDING THE MODEL

(suggested things to add or change in the Code tab to make the model more complicated, detailed, accurate, etc.)

## NETLOGO FEATURES

(interesting or unusual features of NetLogo that the model uses, particularly in the Code tab; or where workarounds were needed for missing features)

## RELATED MODELS

(models in the NetLogo Models Library and elsewhere which are of related interest)

## CREDITS AND REFERENCES

(a reference to the model's URL on the web if it has one, as well as any other necessary credits, citations, and links)
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line bottom
false
0
Rectangle -7500403 true true 0 285 300 300

line half
true
0
Line -7500403 true 150 0 150 150

line left
false
0
Rectangle -7500403 true true 0 0 15 300

line right
false
0
Rectangle -7500403 true true 285 0 300 300

line right and below
false
0
Rectangle -7500403 true true 0 285 300 300
Rectangle -7500403 true true 285 0 300 285

line top
false
0
Rectangle -7500403 true true 0 0 300 15

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270
@#$#@#$#@
NetLogo 6.0.4
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180
@#$#@#$#@
1
@#$#@#$#@
